-- local
local xbsversion="v15.1"
local gv1=nil
local echo=nil
local move_spot_one=nil
local move_spot_two=nil
local current_item_slot=nil 
local current_bag=1
local current_bag_size=nil
local currentslot=1
local current_empty=nil
local current_empty_bag=nil
local last_item_slot=nil
local last_item_bag=nil
local current_empty_slot=nil
local sort_or_not="yes"
local lastsorttime=0
local lastcheckedtime=Inspect.Time.Real()
local sortretries=0
local sort_delay=0.1
local throttle=0
local cthrottle=0
local extra_throttle=0
local sort_iteration=0
local use_throttle=nil
local location="inventory"
local last_changed=500
local changed=0
local xbs_DEBUG=nil
local watcher=nil
local extra_throttle_number=0
local last_watcher=nil
local sort_by="name"
local sorter_event_id=nil
local sort_list={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
local item_list={}
local inverted=nil
local rear=nil
local autosort=nil
local bankautosort=nil
--local ui=false
local invui=false
local bankui=false
local sorting=0
local movelistpos=1
local bagsizes={}
local baglist={}
local current_item
local sortlist={}
local setup_stage=0
local xbsbankqueue="off"
local inv_settings={"Name",{true,true,true,true,true},"A -> Z", "Items First","Normal","NOT_SET","unlocked"}
local bank_settings={"Name",{true,true,true,true,true,true,true,true,true},"A -> Z", "Items First", "Normal","NOT_SET","unlocked"}
local help_text="xBagSort Commands\
	/xbs name - Sorts by name\
	/xbs type - Sorts by type\
	/xbs rarity - Sorts by item quality\
	/xbs ah - Sorts in the same order as the auction house.\
	/xbs quantity - Sorts based on item stack size.\
	/xbs condense - Removes empty slots and shifs items to first bag\
	/xbs abort - Stops sorting\n \
For bank sorting, simply add \"bank\" to the command:\
	\"/xbs bank name\" or \"/xbs name bank\"\
	Any sort type works for the bank as well as your inventory.\n \
For bank vault sorting add \"bv#\" to the command: \
	\"bv1\" sorts vault 1, \"bv2\" sorts vault 2, etc. \
	\"/xbs bv2 name\" or \"/xbs name bv2\" \n \
For guild vault sorting add \"guild#\" to the command: \
	\"guild1\" sorts vault 1, \"guild2\" sorts vault 2, etc. \
	\"/xbs guild2 name\" or \"/xbs name guild2\" \n \
To ignore a bag from sorting, add \"ignore#\" for each bag.\
	\"ignore1 ignore3 ignore4\" would ignore bags 1, 3 and 4\
	This works for both inventory and bank sorting.\n \
Order commands:\
	\"invert\" or \"-i\" will cause the sorting to reverse the order(Z->A).\
	\"rear\" or \"-r\" will put empty slots before the items.\n \
Sorting Speed commands:\
	\"-#\" where # is 1-9 will speed up sorting iterations by 1-9 tenths of a second.\
	\"+#\" where # is 1-9 will slow down sorting iterations by 1-9 tenths of a second.\
	\"throttle\" Enables an extra verification step to confirm a sorting iteration is completed.\n \
Auto-sorting commands:\
	To auto-sort, simply add \"autosort\" or \"auto\" to the command.\
	This will enable auto-sorting whenever inventory bags are opened.\
	\"/xbs rarity auto\" will automatically sort by rarity.\
	\"show\" will display the current auto-sorting method.\
	\"off\" will disable auto-sorting.\
	"
local invhelp_text="Right-Clicking the XBS Button on the inventory window will sort your inventory with the last used settings.\n \
Sort Method: How to order items when sorting.\
	Name - Sorts by name.\
	Type - Sorts by type (weapon, armor, consumable, etc.).\
	Rarity - Sorts by item quality (Relic, Epic, Rare, Etc.).\
	Auction House - Sorts in the same order as the auction house categories.\
	Condense - Removes empty slots and shifts items to first bag, does not change the order of items.\
	Quantity - Sorts based on number of items in stacks. Items with no stack size are sorted as zero.\
	\
Sort Bags: Choose which bags you would like to sort.\
	Unchecked bags will not be included in sorting.\n \
Order: Allows for normal (A->Z) or inverted sorting (Z->A)\n \
Placement: Where items and empty slots are placed in your bag.\
	Empty first leaves open inventory slots at the beginning of your inventory.\
	This can make it easier to find new items.\n\
Sort Speed: Changes how quickly the sorting takes place.\
	High speeds may not sort correctly depending on server lag.\n\
Auto Sort: Enables automatic sorting.\
	Auto sorting occurs when your inventory is opened using whatever settings are above.\
	"
local function getBagSize(bagnumber)
return Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumber))["slots"]
end

local function getOpenBag()
	foundemptybag=0
	for i=1,7 do
		--print(i)
		if(getOpenSlot(i))then
			
			foundemptybag=i
			break
		end
	end
	return foundemptybag
end

local function getFirstItem(bagnumber,slots)
	for i=1, slots do	
			-- if(location=="inventory")then
				-- current_item=Utility.Item.Slot.Inventory(baglist[j],i)
				-- end
			-- if(location=="bank")then--Bank main bag = 1, 2 = bag 1, so j needs to be main or -1
				-- if(baglist[j]==1)then
					-- current_item=Utility.Item.Slot.Bank("main",i)
				-- else
					-- current_item=Utility.Item.Slot.Bank(baglist[j]-1,i)
					-- end
				-- end
			if(location=="verifyguild1")then
				current_item=Utility.Item.Slot.Guild(1,i)
				end
			if(location=="verifyguild2")then
				current_item=Utility.Item.Slot.Guild(2,i)
				end
			if(location=="verifyguild3")then
				current_item=Utility.Item.Slot.Guild(3,i)
				end
			if(location=="verifyguild4")then
				current_item=Utility.Item.Slot.Guild(4,i)
				end
			if(location=="verifyguild5")then
				current_item=Utility.Item.Slot.Guild(5,i)
				end
			--print(current_item)
			if(Inspect.Item.Detail(current_item)) then
				return true
			end
	end
	return false
	end
local function checkguildpermission()
	if(location=="verifyguild1")then
		--curitem=Utility.Item.Slot.Guild(1,2)
		if(getFirstItem(1,105))then
			location="guild1"
		else
			location="guild vault 1 failed"
			end
		end
	if(location=="verifyguild2")then
		--curitem=Utility.Item.Slot.Guild(1,2)
		if(getFirstItem(2,105))then
			location="guild2"
		else
			location="guild vault 2 failed"
			end
		end
	if(location=="verifyguild3")then
		--curitem=Utility.Item.Slot.Guild(1,2)
		if(getFirstItem(3,105))then
			location="guild3"
		else
			location="guild vault 3 failed"
			end
		end
		-- curitem=Utility.Item.Slot.Guild(3,2)
		-- if(Inspect.Item.Detail(curitem)~=nil)then
			-- if(gv1==Inspect.Item.Detail(curitem)["id"])then
				-- Command.Item.Move(Utility.Item.Slot.Guild(3,2),Utility.Item.Slot.Guild(3,1))
				-- location="guild3"
			-- else
				-- location="guild vault 3 failed"
				-- end
		-- else
			-- location="guild vault 3 failed"
			-- end
		-- end
		if(location=="verifyguild4")then
			--curitem=Utility.Item.Slot.Guild(1,2)
			if(getFirstItem(4,105))then
				location="guild4"
			else
				location="guild vault 4 failed"
				end
			end
		if(location=="verifyguild5")then
			--curitem=Utility.Item.Slot.Guild(1,2)
		if(getFirstItem(5,105))then
			location="guild5"
		else
			location="guild vault 5 failed"
			end
		end
	if(location=="checkguild1")then
		curitem=Utility.Item.Slot.Guild(1,1)
		if(Inspect.Item.Detail(curitem)~=nil)then
			gv1=Inspect.Item.Detail(curitem)["id"]
			Command.Item.Move(Utility.Item.Slot.Guild(1,1),Utility.Item.Slot.Guild(1,2))
			location="verifyguild1"
		else
			location="guild vault 1 failed"
			end
		end
	if(location=="checkguild2")then
		curitem=Utility.Item.Slot.Guild(2,1)
		if(Inspect.Item.Detail(curitem)~=nil)then
			gv1=Inspect.Item.Detail(curitem)["id"]
			Command.Item.Move(Utility.Item.Slot.Guild(2,1),Utility.Item.Slot.Guild(2,2))
			location="verifyguild2"
		else
			location="guild vault 2 failed"
			end
		end
	if(location=="checkguild3")then
		curitem=Utility.Item.Slot.Guild(3,1)
		if(Inspect.Item.Detail(curitem)~=nil)then
			gv1=Inspect.Item.Detail(curitem)["id"]
			Command.Item.Move(Utility.Item.Slot.Guild(3,1),Utility.Item.Slot.Guild(3,2))
			location="verifyguild3"
		else
			location="guild vault 3 failed"
			end
		end
	if(location=="checkguild4")then
		curitem=Utility.Item.Slot.Guild(4,1)
		if(Inspect.Item.Detail(curitem)~=nil)then
			gv1=Inspect.Item.Detail(curitem)["id"]
			Command.Item.Move(Utility.Item.Slot.Guild(4,1),Utility.Item.Slot.Guild(4,2))
			location="verifyguild4"
		else
			location="guild vault 4 failed"
			end
		end
	if(location=="checkguild5")then
		curitem=Utility.Item.Slot.Guild(5,1)
		if(Inspect.Item.Detail(curitem)~=nil)then
			gv1=Inspect.Item.Detail(curitem)["id"]
			Command.Item.Move(Utility.Item.Slot.Guild(5,1),Utility.Item.Slot.Guild(5,2))
			location="verifyguild5"
		else
			location="guild vault 5 failed"
			end
		end
	
	
	
end



local function getOpenSlot(bagnumber,startslot)
	foundempty=nil
	if(not(startslot))then
		startslot=1
	end
--	print("Bagnumber:")
--	print(bagnumber)
	bagsize=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumber))["slots"]
	for i=startslot, bagsize do
		--print(i)
		current_item=Utility.Item.Slot.Inventory(bagnumber,i)
		if(not(Inspect.Item.Detail(current_item))) then
			foundempty=i
			break
		else
			if(movelist[1])then
				for j=1,movelistpos do
					if(movelist[j])then
						if(movelist[j][1]==bagnumber and movelist[j][2]==i)then
							return i
						end
					end
				end
			end
		end
	end
	if(not(foundempty))then
		return nil
	end
	return foundempty
end

--Convert item rarity to sortable numbers
local function rareconvert(arg)
	if(arg=="transcendent")then
		return 010 end
	if(arg=="relic")then
		return 020 end
	if(arg=="epic")then
		return 030 end
	if(arg=="rare")then
		return 040 end
	if(arg=="uncommon")then
		return 050 end
	if(arg=="quest")then
		return 060 end
	if(arg=="sellable")then
		return 070 end
	return 080
	end

	
--Convert item types to number based on order of apperance on the Auction house.

local function ahconvert(arg)
	if(arg=="armor plate chest")then
		return 010 end
	if(arg=="armor plate legs")then
		return 020 end
	if(arg=="armor plate feet")then
		return 030 end
	if(arg=="armor plate hands")then
		return 040 end
	if(arg=="armor plate head")then
		return 050 end
	if(arg=="armor plate shoulders")then
		return 060 end
	if(arg=="armor plate waist")then
		return 070 end
	if(arg=="armor chain chest")then
		return 080 end
	if(arg=="armor chain legs")then
		return 090 end
	if(arg=="armor chain feet")then
		return 100 end
	if(arg=="armor chain hands")then
		return 110 end
	if(arg=="armor chain head")then
		return 120 end
	if(arg=="armor chain shoulders")then
		return 130 end
	if(arg=="armor chain waist")then
		return 140 end
	if(arg=="armor leather chest")then
		return 150 end
	if(arg=="armor leather legs")then
		return 160 end
	if(arg=="armor leather feet")then
		return 170 end
	if(arg=="armor leather hands")then
		return 180 end
	if(arg=="armor leather head")then
		return 190 end
	if(arg=="armor leather shoulders")then
		return 200 end
	if(arg=="armor leather waist")then
		return 210 end
	if(arg=="armor cloth chest")then
		return 220 end
	if(arg=="armor cloth legs")then
		return 230 end
	if(arg=="armor cloth feet")then
		return 240 end
	if(arg=="armor cloth hands")then
		return 250 end
	if(arg=="armor cloth head")then
		return 260 end
	if(arg=="armor cloth shoulders")then
		return 270 end
	if(arg=="armor cloth waist")then
		return 280 end
	if(arg=="armor accessory neck")then
		return 290 end
	if(arg=="armor accessory ring")then
		return 300 end
	if(arg=="armor accessory trinket")then
		return 310 end
	if(arg=="armor accessory seal")then
		return 320 end
	if(arg=="armor costume")then
		return 330 end
	if(arg=="armor cape")then
		return 340 end
	if(arg=="weapon onehand sword")then
		return 350 end
	if(arg=="weapon onehand axe")then
		return 360 end
	if(arg=="weapon onehand mace")then
		return 370 end
	if(arg=="weapon onehand dagger")then
		return 380 end
	if(arg=="weapon onehand sword")then
		return 390 end
	if(arg=="weapon twohand sword")then
		return 400 end
	if(arg=="weapon twohand axe")then
		return 410 end
	if(arg=="weapon twohand mace")then
		return 420 end
	if(arg=="weapon twohand polearm")then
		return 430 end
	if(arg=="weapon twohand staff")then
		return 440 end
	if(arg=="weapon ranged bow")then
		return 450 end
	if(arg=="weapon ranged gun")then
		return 460 end
	if(arg=="weapon ranged wand")then
		return 470 end
	if(arg=="weapon totem")then
		return 480 end
	if(arg=="weapon shield")then
		return 490 end
	if(arg=="planar lesser")then
		return 500 end
	if(arg=="planar greater")then
		return 510 end
	if(arg=="consumable food")then
		return 520 end
	if(arg=="consumable drink")then
		return 530 end
	if(arg=="consumable potion")then
		return 540 end
	if(arg=="consumable scroll")then
		return 550 end
	if(arg=="consumable enchantment")then
		return 560 end
	if(arg=="consumable consumable")then
		return 570 end
	if(arg=="container")then
		return 580 end
	if(arg=="crafting")then
		return 590 end
	if(arg=="crafting recipe apothecary")then
		return 590 end
	if(arg=="crafting recipe apothecary")then
		return 590 end
	if(arg=="crafting recipe armorsmith")then
		return 600 end
	if(arg=="crafting recipe artificer")then
		return 610 end
	if(arg=="crafting recipe butchering")then
		return 620 end
	if(arg=="crafting recipe foraging")then
		return 630 end
	if(arg=="crafting recipe weaponsmith")then
		return 640 end
	if(arg=="crafting recipe outfitter")then
		return 650 end
	if(arg=="crafting recipe mining")then
		return 660 end
	if(arg=="crafting recipe runecrafting")then
		return 670 end
	if(arg=="crafting recipe fishing")then
		return 680 end
	if(arg=="crafting recipe survival")then
		return 690 end
	if(arg=="crafting material metal")then
		return 700 end
	if(arg=="crafting material gem")then
		return 710 end
	if(arg=="crafting material wood")then
		return 720 end
	if(arg=="crafting material plant")then
		return 730 end
	if(arg=="crafting material hide")then
		return 740 end
	if(arg=="crafting material meat")then
		return 750 end
	if(arg=="crafting material cloth")then
		return 760 end
	if(arg=="crafting material component")then
		return 770 end
	if(arg=="crafting material fish")then
		return 780 end
	if(arg=="crafting material butcher")then
		return 790 end
	if(arg=="crafting ingredient")then
		return 590 end
	if(arg=="crafting ingredient reagent")then
		return 800 end
	if(arg=="crafting ingredient drop")then
		return 810 end
	if(arg=="crafting ingredient rift")then
		return 820 end
	if(arg=="crafting augment")then
		return 830 end
	if(arg=="misc quest")then
		return 840 end
	if(arg=="misc mount")then
		return 850 end
	if(arg=="misc pet")then
		return 860 end
	if(arg=="misc collectible")then
		return 870 end
	if(arg=="misc other")then
		return 880 end
	if(arg=="misc survival")then
		return 890 end
	if(arg=="misc fishing")then
		return 900 end
	if(arg=="misc")then
		return 910 end
	if(arg=="dimension lighting")then
		return 920 end
	if(arg=="dimension dimension key")then
		return 930 end
	if(arg=="dimension key")then
		return 940 end
	if(arg=="dimension building")then
		return 950 end
	if(arg=="dimension world event")then
		return 960 end
	if(arg=="dimension decoration")then
		return 970 end
	if(arg=="dimension decoration large")then
		return 980 end
	if(arg=="dimension decoration small")then
		return 990 end
	if(arg=="dimension decoration container")then
		return 1000 end
	if(arg=="dimension decoration household")then
		return 1010 end
	if(arg=="dimension block")then
		return 1020 end
	if(arg=="dimension furniture")then
		return 1030 end
	if(arg=="dimension module")then
		return 1040 end
	if(arg=="dimension interactive")then
		return 1050 end
	if(arg=="dimension planar")then
		return 1060 end
	if(arg=="dimension landscaping barrier")then
		return 1070 end
	if(arg=="dimension landscaping rock")then
		return 1080 end
	if(arg=="dimension landscaping tree")then
		return 1090 end
	if(arg=="dimension landscaping plant")then
		return 1100 end
		
	if(arg=="artifacts normal")then
		return 1110 end
	if(arg=="artifacts twisted")then
		return 1120 end
	if(arg=="artifacts unstable")then
		return 1130 end
	if(arg=="artifacts bounty")then
		return 1140 end
	if(arg=="artifacts other")then
		return 1150 end
	if(arg=="artifacts fishing")then
		return 1160 end
	
	
	
	
	
	
	return 1510 
end



local function xmovelist(method)
	
	current_item_slot=nil 
	current_bag=1
	current_bag_size=nil
	currentslot=1
	current_empty=nil
	current_empty_bag=nil
	last_item_slot=nil
	last_item_bag=nil
	current_empty_slot=nil
	
	sortlist={}
	--sortlistpos=1
	movelist={}
	movelistpos=1
	last_item_bag=nil
	last_item_slot=nil
	--current_empty_bag=getOpenBag()
	bagsizes={}
	baglist={}
	--print(location)
	if(location=="inventory")then
		baglist={}
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",1)))then
			table.insert(baglist,1)
			bagsizes[1]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",1))["slots"]
			end
		if(sort_list[2] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",2)))then
			table.insert(baglist,2)
			bagsizes[2]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",2))["slots"]
			end
		if(sort_list[3] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",3)))then
			table.insert(baglist,3)
			bagsizes[3]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",3))["slots"]
			end
		if(sort_list[4] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",4)))then
			table.insert(baglist,4)
			bagsizes[4]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",4))["slots"]
			end
		if(sort_list[5] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",5)))then
			table.insert(baglist,5)
			bagsizes[5]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",5))["slots"]
			end
		if(sort_list[6] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",6)))then
			table.insert(baglist,6)
			bagsizes[6]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",6))["slots"]
			end
		if(sort_list[7] and Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",7)))then
			table.insert(baglist,7)
			bagsizes[7]=Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",7))["slots"]
			end
		item_list={}
		end
	if(location=="guild1")then
		bagsizes={}
		if(Inspect.Item.Detail(Utility.Item.Slot.Guild(1)))then
			bagsizes[1]=105
			table.insert(baglist,1)
			item_list={}
			end
	elseif(location=="guild2")then
		bagsizes={}
		if(Inspect.Item.Detail(Utility.Item.Slot.Guild(2)))then
			bagsizes[1]=105
			table.insert(baglist,1)
			item_list={}
			end
	elseif(location=="guild3")then
		bagsizes={}
		if(Inspect.Item.Detail(Utility.Item.Slot.Guild(3)))then
			bagsizes[1]=105
			table.insert(baglist,1)
			item_list={}
			end
	elseif(location=="guild4")then
		bagsizes={}
		if(Inspect.Item.Detail(Utility.Item.Slot.Guild(4)))then
			bagsizes[1]=105
			table.insert(baglist,1)
			item_list={}
			end
	elseif(location=="guild5")then
		bagsizes={}
		table.insert(baglist,1)
		if(Inspect.Item.Detail(Utility.Item.Slot.Guild(5)))then
			bagsizes[1]=105
			item_list={}
			end
		end
	if(location=="bv1")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(1)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
		end
		
	if(location=="bv2")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(2)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
		end
	if(location=="bv3")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(3)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
	end
	if(location=="bv4")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(4)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
	end
	if(location=="bv5")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(5)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
	end
	if(location=="bv6")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(6)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
	end
	if(location=="bv7")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Vault(7)))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		
		item_list={}
	end
	if(location=="bank")then
		bagsizes={}
		if(sort_list[1] and Inspect.Item.Detail(Utility.Item.Slot.Bank("main")))then
			bagsizes[1]=32
			table.insert(baglist,1)
			end
		if(sort_list[2] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",1)))then
			bagsizes[2]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",1))["slots"]
			table.insert(baglist,2)
			end
		if(sort_list[3] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",2)))then
			bagsizes[3]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",2))["slots"]
			table.insert(baglist,3)
			end
		if(sort_list[4] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",3)))then
			bagsizes[4]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",3))["slots"]
			table.insert(baglist,4)
			end
		if(sort_list[5] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",4)))then
			bagsizes[5]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",4))["slots"]
			table.insert(baglist,5)
			end
		if(sort_list[6] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",5)))then
			bagsizes[6]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",5))["slots"]
			table.insert(baglist,6)
			end
		
		if(sort_list[7] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",6)))then
			bagsizes[7]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",6))["slots"]
			table.insert(baglist,7)
			end
		if(sort_list[8] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",7)))then
			bagsizes[8]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",7))["slots"]
			table.insert(baglist,8)
			end
		if(sort_list[9] and Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",8)))then
			bagsizes[9]=Inspect.Item.Detail(Utility.Item.Slot.Bank("bag",8))["slots"]
			table.insert(baglist,9)
			end
		if(sort_list[10] and Inspect.Item.Detail(Utility.Item.Slot.Vault(2,1)))then
			bagsizes[10]=32
			table.insert(baglist,10)
			end
		if(sort_list[11] and Inspect.Item.Detail(Utility.Item.Slot.Vault(3,1)))then
			bagsizes[11]=32
			table.insert(baglist,11)
			end
		if(sort_list[12] and Inspect.Item.Detail(Utility.Item.Slot.Vault(4,1)))then
			bagsizes[12]=32
			table.insert(baglist,12)
			end
		if(sort_list[13] and Inspect.Item.Detail(Utility.Item.Slot.Vault(5,1)))then
			bagsizes[13]=32
			table.insert(baglist,13)
			end
		if(sort_list[14] and Inspect.Item.Detail(Utility.Item.Slot.Vault(6,1)))then
			bagsizes[14]=32
			table.insert(baglist,14)
			end
		if(sort_list[15] and Inspect.Item.Detail(Utility.Item.Slot.Vault(7,1)))then
			bagsizes[15]=32
			table.insert(baglist,15)
			end
		item_list={}
		end
	--Get all items in bags
	for j=1, table.getn(baglist) do
		
		for i=1, bagsizes[baglist[j]] do	
			if(location=="inventory")then
				current_item=Utility.Item.Slot.Inventory(baglist[j],i)
				end
			if(location=="bank")then--Bank main bag = 1, 2 = bag 1, so j needs to be main or -1
				if(baglist[j]==1)then
					current_item=Utility.Item.Slot.Bank("main",i)
				elseif(baglist[j]>=10)then
					current_item=Utility.Item.Slot.Vault(baglist[j]-8,i)--Vaults start at 2 (not counting main fault)
				else
					current_item=Utility.Item.Slot.Bank(baglist[j]-1,i)
					end
				end
			if(location=="bv1")then
				current_item=Utility.Item.Slot.Vault(1,i)
				end
			if(location=="bv2")then
				current_item=Utility.Item.Slot.Vault(2,i)
				end
			if(location=="bv3")then
				current_item=Utility.Item.Slot.Vault(3,i)
				end
			if(location=="bv4")then
				current_item=Utility.Item.Slot.Vault(4,i)
				end
			if(location=="bv5")then
				current_item=Utility.Item.Slot.Vault(5,i)
				end
			if(location=="bv6")then
				current_item=Utility.Item.Slot.Vault(6,i)
				end
			if(location=="bv7")then
				current_item=Utility.Item.Slot.Vault(7,i)
				end
			if(location=="guild1")then
				current_item=Utility.Item.Slot.Guild(1,i)
				end
			if(location=="guild2")then
				current_item=Utility.Item.Slot.Guild(2,i)
				end
			if(location=="guild3")then
				current_item=Utility.Item.Slot.Guild(3,i)
				end
			if(location=="guild4")then
				current_item=Utility.Item.Slot.Guild(4,i)
				end
			if(location=="guild5")then
				current_item=Utility.Item.Slot.Guild(5,i)
				end
			--print(current_item)
			if(Inspect.Item.Detail(current_item)) then
				--print(Inspect.Item.Detail(current_item)["name"])
				--item_list=item_list, {current_item,Inspect.Item.Detail(current_item)["name"]}
				
				
				if(sort_by=="ah")then
					nline={current_item,Inspect.Item.Detail(current_item)["category"],nil,Inspect.Item.Detail(current_item)["name"],Inspect.Item.Detail(current_item)["stack"],Inspect.Item.Detail(current_item)["id"]}
				else
					local s=Inspect.Item.Detail(current_item)[sort_by]
					
					if(s=="" or s==nil)then
						
					
						s="zzzzzzzzzzzzzzzzzzz"
						if(sort_by=="stack")then
							s=0
							end
						end
					
					nline={current_item,s,nil,Inspect.Item.Detail(current_item)["name"],Inspect.Item.Detail(current_item)["stack"],Inspect.Item.Detail(current_item)["id"]}
				end
				table.insert(item_list,nline)
			end
		end
	end
	--Rarity sort convert
	if(sort_by=="rarity")then
		for i=1, table.getn(item_list)do
			item_list[i][2]=rareconvert(item_list[i][2])
		end
	end
	if(sort_by=="ah")then
		for i=1, table.getn(item_list)do
			item_list[i][2]=ahconvert(item_list[i][2])
		end
	end
	if(sort_by=="condense")then
		for i=1, table.getn(item_list)do
			item_list[i][2]=i
		end
		if(rear==1)then
			invert=1
		end
	end
	--Sort items by name
	--[[table.sort(item_list,function(a,b)
		if(a[2] and b[2])then
			if a[2]==nil or b[2]==nil then
				return a[2]<b[2]
			end
			if(a[2]==b[2] and a[4]==b[4])then
					if(a[5]==nil or b[5]==nil) then 
						return a[4]<b[4]
						end
					if a[5]==b[5]then
						return a[5]>b[5]
						end
					
					return a[5]>b[5]		
			else		
				
				return a[2]<b[2] or a[2]==b[2] and a[4]<b[4]	
			end
			return a[2]<b[2]
		end
		end)--]]
	if(sort_or_not=="yes")then --Perform ordering of item_list
		if(invert==1)then
			table.sort(item_list,function(b,a)
			if(a[2] and b[2])then
				if a[2]==nil or b[2]==nil then
					return a[2]<b[2]
					
				else
					if(a[5] and b[5])then
						if(a[2]==b[2] and a[4]==b[4] and a[5]==b[5])then
							return a[6]>b[6]
						end
						if(a[2]==b[2] and a[4]==b[4])then
							return a[5]>b[5]	
						end
						return a[2]<b[2] or a[2]==b[2] and a[4]<b[4]
					end
					if(a[2]==b[2] and a[4]==b[4])then
						return a[6]>b[6]
						end
					return a[2]<b[2] or a[2]==b[2] and a[4]<b[4]
						end
					end
				end)
		else
			table.sort(item_list,function(a,b)
			if(a[2] and b[2])then
				if a[2]==nil or b[2]==nil then
					return a[2]<b[2]
					
				else
					if(a[5] and b[5])then
						if(a[2]==b[2] and a[4]==b[4] and a[5]==b[5])then
							return a[6]>b[6]
						end
						if(a[2]==b[2] and a[4]==b[4])then
							return a[5]<b[5]	
						end
						
						return a[2]<b[2] or a[2]==b[2] and a[4]<b[4]
					end
					if(a[2]==b[2] and a[4]==b[4])then
						return a[6]>b[6]
						end
					return a[2]<b[2] or a[2]==b[2] and a[4]<b[4]
				end
			end
			end)
			end
			
		end
	--Get bag slots.		
	--number_of_items=table.getn(item_list)
	local number_of_current_item=1
	
	--for j=1, last_bag_slot do
		--for i=1, bagsizes[j] do	
	for j=1, table.getn(baglist) do
		for i=1, bagsizes[baglist[j]] do		
			local detail
			local name
				if(location=="inventory")then
					local dest=Utility.Item.Slot.Inventory(baglist[j],i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Inventory(baglist[j],i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Inventory(baglist[j],i))["name"]
						end--]]
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="guild1")then
					local dest=Utility.Item.Slot.Guild(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Guild(1,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Guild(1,i))["name"]
						end--]]

					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="guild2")then
					local dest=Utility.Item.Slot.Guild(2,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Guild(2,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Guild(2,i))["name"]
						end--]]
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="guild3")then
					local dest=Utility.Item.Slot.Guild(3,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Guild(3,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Guild(3,i))["name"]
						end--]]

					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="guild4")then
					local dest=Utility.Item.Slot.Guild(4,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Guild(4,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Guild(4,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="guild5")then
					local dest=Utility.Item.Slot.Guild(5,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Guild(5,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Guild(5,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
					
				elseif(location=="bv1")then
					local dest=Utility.Item.Slot.Vault(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(1,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(1,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv2")then
					local dest=Utility.Item.Slot.Vault(2,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(2,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(2,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv3")then
					local dest=Utility.Item.Slot.Vault(3,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(3,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(3,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv4")then
					local dest=Utility.Item.Slot.Vault(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(4,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(4,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv5")then
					local dest=Utility.Item.Slot.Vault(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(5,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(5,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv6")then
					local dest=Utility.Item.Slot.Vault(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(6,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(6,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				elseif(location=="bv7")then
					local dest=Utility.Item.Slot.Vault(1,i)
					--[[v14_removed__if(Inspect.Item.Detail(dest))then
						detail=Inspect.Item.Detail(Utility.Item.Slot.Vault(7,i))[sort_by]
						name=Inspect.Item.Detail(Utility.Item.Slot.Vault(7,i))["name"]
						end--]]
					
					
					sortlist[number_of_current_item]={dest,detail,name}
					number_of_current_item=number_of_current_item+1
				else--Bank main bag = 1, 2 = bag 1, so j needs to be main or -1
					if(baglist[j]==1)then
						local dest=Utility.Item.Slot.Bank("main",i)
						--[[v14_removed__if(Inspect.Item.Detail(dest))then
							detail=Inspect.Item.Detail(Utility.Item.Slot.Bank("main",i))[sort_by]
							name=Inspect.Item.Detail(Utility.Item.Slot.Bank("main",i))["name"]
							end--]]
						sortlist[number_of_current_item]={dest,detail,name}
						number_of_current_item=number_of_current_item+1
						
					elseif(baglist[j]>=10)then
						local dest=Utility.Item.Slot.Vault(baglist[j]-8,i)
						sortlist[number_of_current_item]={dest,detail,name}
						number_of_current_item=number_of_current_item+1
					else
						local dest=Utility.Item.Slot.Bank(baglist[j]-1,i)
						--[[v14_removed__if(Inspect.Item.Detail(dest))then
							detail=Inspect.Item.Detail(Utility.Item.Slot.Bank(baglist[j]-1,i))[sort_by]
							name=Inspect.Item.Detail(Utility.Item.Slot.Bank(baglist[j]-1,i))["name"]
							end--]]
						sortlist[number_of_current_item]={dest,detail,name}
						number_of_current_item=number_of_current_item+1
						
						end
					end
			end
		end
	if(rear==1)then
		for i=1, table.getn(item_list) do
			if(item_list[i])then
				if(item_list[i][1]~=sortlist[table.getn(sortlist)-i+1][1])then -- and item_list[i][2]~=sortlist[i][2] and item_list[i][4]~=sortlist[i][3]
					item_list[i][3]=sortlist[table.getn(sortlist)-i+1][1]
					--print("Moving "..item_list[i][1].." to "..item_list[i][3])
				end
			end
		end
	else
		for i=1, table.getn(item_list) do
			if(item_list[i])then
				if(item_list[i][1]~=sortlist[i][1])then -- and item_list[i][2]~=sortlist[i][2] and item_list[i][4]~=sortlist[i][3]
					item_list[i][3]=sortlist[i][1]
					--print("Moving "..item_list[i][1].." to "..item_list[i][3])
				end
			end
		end
		end
	changed=0
end


local function xsorter()
	if(sorting==0)then
		return
		end
	lastsorttime=lastsorttime+Inspect.Time.Real()-lastcheckedtime
	if(sort_iteration==0)then
		if(location=="checkguild1" or location=="checkguild2" or location=="checkguild3" or location=="checkguild4" or location=="checkguild5" or location=="verifyguild1" or location=="verifyguild2" or location=="verifyguild3" or location=="verifyguild4" or location=="verifyguild5") then
			--do nothing
		else
			lastsorttime=sort_delay+0.0001
		end
		end
	while(lastsorttime>sort_delay)do
		--print(watcher)
		local total_items=0
		local lock_list=""
		lastsorttime = lastsorttime - sort_delay
		if(location=="checkguild1" or location=="checkguild2" or location=="checkguild3" or location=="checkguild4" or location=="checkguild5" or location=="verifyguild1" or location=="verifyguild2" or location=="verifyguild3" or location=="verifyguild4" or location=="verifyguild5") then
			--print(location)
			lastsorttime = lastsorttime - 0.5
			checkguildpermission()
		elseif(location=="guild vault 1 failed" or location=="guild vault 2 failed" or location=="guild vault 3 failed" or location=="guild vault 4 failed" or location=="guild vault 5 failed")then
				sorting=0
				print("Sorting of "..location.." make sure you are at the guild banker and have permission.")
				--remove from update event
				if(xbs_DEBUG)then
					print("Unhooking")
					end
				--table.remove(Event.System.Update.Begin,sorter_event_id);
				for idx, eventData in ipairs(Event.System.Update.Begin) do
					if eventData == sorter_event_id then
						table.remove(Event.System.Update.Begin, idx)
						break
					end
				end
		elseif(watcher)then
			
			lastsorttime = lastsorttime - sort_delay - throttle
			if(last_watcher==nil)then
				last_watcher=""
				--print("last_watcher set")
				for i=1, table.getn(item_list) do
					if(item_list[i] and item_list[i][1] and item_list[i][3] and item_list[i][2])then
						last_watcher=""..last_watcher..""..item_list[i][2]
						end
					end
				
			else
				checkwatcher=""
				for i=1, table.getn(item_list) do
					if(item_list[i] and item_list[i][1] and item_list[i][3] and item_list[i][2])then
						checkwatcher=""..checkwatcher..""..item_list[i][2]
						end
					end
					--check_watcher=Inspect.Item.Detail(watcher[3])["name"]
					--print(watcher[4].." - "..check_watcher)
					if(checkwatcher==last_watcher)then
						watcher=nil
						last_watcher=nil
						lastsorttime=lastsorttime
						--print("Watcher Cleared")
					else
						--print("Watcher not matching")
						last_watcher=nil
						end
				end
		else
			--print(location)
			xmovelist()
			--print(table.getn(item_list))
			
			sort_iteration=sort_iteration+1
			lastsorttime = lastsorttime - sort_delay
			if(last_changed<=table.getn(item_list) or last_changed==500)then
				local amount=0
				
				if(use_throttle)then
					watcher="check"
					end
				lock_list=""
				for i=1, table.getn(item_list) do
					
					if(item_list[i] and item_list[i][1] and item_list[i][3] and item_list[i][2])then
						
						
						--print("watcher set")
						
						
						--[[if(location=="guild1" or location=="guild2" or location=="guild3" or location=="guild4" or location=="guild5")then
							amount=amount+1
							Command.Item.Move(item_list[i][1],item_list[i][3])
						else end--]]
							
						amount=amount+1
						if(item_list[i][1]~=item_list[i][3] and amount<75)then
							
							if(not(lock_list.find(lock_list,item_list[i][3])) and not(lock_list.find(lock_list,item_list[i][1])) and not(sort_by=="condense"))then
								changed=changed+1
								lock_list=lock_list..item_list[i][3]..item_list[i][1]
								Command.Item.Move(item_list[i][1],item_list[i][3])
								if(xbs_DEBUG)then
									print("Moving "..item_list[i][1].." to "..item_list[i][3].." "..item_list[i][2])
									if(item_list[i][5])then
										print("ilist 1:"..item_list[i][1].." 2: "..item_list[i][2].." 3: "..item_list[i][3].." 4: "..item_list[i][4].." 5: "..item_list[i][5])
									else
										print("ilist 1:"..item_list[i][1].." 2: "..item_list[i][2].." 3: "..item_list[i][3].." 4: "..item_list[i][4])
										end
									end
							else
								changed=changed+1
								lock_list=lock_list..item_list[i][3]..item_list[i][1]
								Command.Item.Move(item_list[i][1],item_list[i][3])
								end
								
							
								
								

							end
						if(item_list[i][1]~=item_list[i][3])then
							total_items=total_items+1
							end
						
						
						
						--Removed 14.4
						--[[for j=1, table.getn(item_list)do
							
							if(item_list[j][1]==item_list[i][3])then
								
								if(item_list[i][5] and item_list[j][5])then
									if(item_list[i][2]==item_list[j][2] and item_list[i][4]==item_list[j][4] and item_list[i][5]==item_list[j][5])then
										changed=changed-1
										
									else
										if(item_list[j][4]==item_list[i][4])then
											changed=changed-1
											end
										end
								else
									if(item_list[j][4]==item_list[i][4])then
										changed=changed-1
										end
									
									end
								
								end
						
							end--]]
						end
					
					end
				end
			--print(sort_iteration)
			throttle=(changed*0.01)+0.03
			
			if(echo)then print("Sorting in progress: "..changed.." of "..total_items.." items moved.") end	
			if(changed<=0)then
				sorting=0
				extra_throttle=0
				
				if(echo)then print("Sorting completed!") end
				--remove from update event
				if(xbs_DEBUG)then
					print("Unhooking")
					end
				--table.remove(Event.System.Update.Begin,sorter_event_id);
				for idx, eventData in ipairs(Event.System.Update.Begin) do
					if eventData == sorter_event_id then
						table.remove(Event.System.Update.Begin, idx)
						break
					end
				end
				if(xbsbankqueue=="inventory")then
					if(xbs_DEBUG)then
						print("Commencing bank sorting")
					end
					
					xbsbankqueue="bank"
					xbscommands(bankautosort)
					return
				end
				if(xbsbankqueue=="bank")then
					if(xbs_DEBUG)then
						print("Finished sorting bank queue")
					end
					xbsbankqueue="off"
				end
				end
			if(last_changed==changed and location=="bank" and changed<0)then
				--sorting=0
				--extra_throttle=0
				print("Error: You must have your bank open to sort it.")
				--print("Sorting aborted please try again.")
				--table.remove(Event.System.Update.Begin,sorter_event_id);
				end
			--[[if(last_changed<changed)then -- If Sorting has fallen completely behind apply emergency break
					if(extra_throttle_number<=2)then
						extra_throttle_number=extra_throttle_number+1
						extra_throttle=2+extra_throttle_number*0.5
						sort_delay=sort_delay+0.1
						
						print("Warning: (Code 1) Last iteration still in progress, attempting to resolve...")
					else
						extra_throttle=extra_throttle+extra_throttle_number*0.5
						use_throttle=1
						print("Warning: (Code 1) Sorting iteration error still occuring, enabling throttling.")
						end
				
				
				
			else
				if(extra_throttle_number>0)then
					print("(Code 1) appears to have been resolved.")
					extra_throttle_number=extra_throttle_number-1
					extra_throttle=extra_throttle_number*0.5
					end
				end]]
				
			--*if(changed/last_changed>0.8 and changed>10)then -- If sorting isn't keeping up, increase delay, and increase throttle for this iteration.
				--sort_delay=sort_delay+0.1
				--throttle=throttle*3
				--end
			last_changed=changed
			if(sort_iteration>=20)then
				sorting=0
				extra_throttle=0
				if(echo)then print("Sorting aborted please try again.") end
				--remove from update event
				if(xbs_DEBUG)then
					print("Unhooking")
					end
				--table.remove(Event.System.Update.Begin,sorter_event_id);
				for idx, eventData in ipairs(Event.System.Update.Begin) do
					if eventData == sorter_event_id then
						table.remove(Event.System.Update.Begin, idx)
						break
					end
				end
				end
			if(xbs_DEBUG)then
				print("Throttle = "..throttle)
				end
			lastsorttime = lastsorttime - sort_delay-throttle-extra_throttle
			end
		
		
	end
	
	lastcheckedtime = Inspect.Time.Real()
end

--Window
	local context = UI.CreateContext("xbsContext")
	local xbswindow = UI.CreateFrame("RiftWindow", "xbsWindow", context)
	xbswindow:SetPoint("CENTER", UIParent,"CENTER")
	xbswindow:SetTitle("xBagSort Help")
	xbswindow:SetLayer(7) 
	xbswindow:SetVisible(false) 
	--button
	local xbsbutton = UI.CreateFrame("RiftButton", "xbsCloseButton", context)
	xbsbutton:SetText("Close")
	-- Put the button in the middle of the screen
	xbsbutton:SetPoint("BOTTOMCENTER", xbswindow,"BOTTOMCENTER",0,-10)
	xbsbutton:SetVisible(false) 
	xbsbutton:SetLayer(8) 
	
	-- Run a function when the button is pressed
	-- Create our context --
	local xbstext = UI.CreateFrame("Text", "SampleText", context)
	-- Hello World! --
	xbstext:SetText(help_text)
	xbstext:SetVisible(false) 
	-- Change the dimensions so all text is visible --
	xbstext:SetWidth(xbstext:GetWidth())
	xbstext:SetHeight(xbstext:GetHeight())
	xbswindow:SetWidth(xbstext:GetWidth()+100)
	xbswindow:SetHeight(xbstext:GetHeight()+100)
	xbstext:SetLayer(8) 
	-- Put it at the top center of the game --
	xbstext:SetPoint("TOPLEFT", xbswindow,"TOPLEFT",25,65)
	
	--INVENTORY UI
	local xbsinventory_button=UI.CreateFrame("Texture","xBagSort",context)
		xbsinventory_button:SetVisible(false)
		-- xbsinventory_button:SetText("XBS")
		-- xbsinventory_button:SetPoint("BOTTOMCENTER", UI.Native.BagInventory1,"BOTTOMCENTER",0,20)
		-- xbsinventory_button:SetLayer(2)
	local xbsinventory_window= UI.CreateFrame("RiftWindow","xBagSort",context)
		xbsinventory_window:SetVisible(false)
		xbsinventory_window:SetTitle("xBagSort")
		--xbsinventory_window:SetPoint("BOTTOMLEFT", UI.Native.BagInventory1,"BOTTOMLEFT",0,0)
		xbsinventory_window:SetLayer(2)
		xbsinventory_window:SetHeight(375)
	
	local xbsinventory_text= UI.CreateFrame("Text","xBagSort",context)
		xbsinventory_text:SetVisible(false)
local xbsitext="Sort Method:\
\
		1    2    3   4   5   6    7\
Sort Bag:\
\
Order:  		  Placement:\
\
Sort Speed:\
\
Auto Sort:\
\
\
\
\
\
\
"..xbsversion
		xbsinventory_text:SetText(xbsitext)
		xbsinventory_text:SetWidth(xbsinventory_text:GetWidth())
		xbsinventory_text:SetHeight(xbsinventory_text:GetHeight())
		--xbswindow:SetWidth(xbstext:GetWidth()+100)
		 
		-- Put it at the top c	enter of the game --
		xbsinventory_window:SetWidth(xbsinventory_text:GetWidth()+125)
		--xbsinventory_window:SetPoint("BOTTOMLEFT", UI.Native.BagInventory1,"BOTTOMLEFT",(xbsinventory_text:GetWidth()+125)*-1,0)
		xbsinventory_text:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",25,65)
		--xbsinventory_text:SetPoint("BOTTOMCENTER", UI.Native.BagInventory1,"BOTTOMCENTER",0,15)
		xbsinventory_text:SetLayer(3)
	local xbsinventory_helpbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsinventory_helpbutton:SetVisible(false)
		xbsinventory_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
		--xbsinventory_helpbutton:ResizeToTexture()
		xbsinventory_helpbutton:SetPoint("BOTTOMRIGHT", xbsinventory_window,"BOTTOMRIGHT",-10,-10)
		xbsinventory_helpbutton:SetLayer(3)
	local xbsinventory_lockbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsinventory_lockbutton:SetVisible(false)
		xbsinventory_lockbutton:SetTexture("xBagSort","textures/unlocked.png")
		--xbsinventory_lockbutton:ResizeToTexture()
		xbsinventory_lockbutton:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",10,15)
		xbsinventory_lockbutton:SetLayer(3)
	local xbsinventory_configbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsinventory_configbutton:SetVisible(false)
		xbsinventory_configbutton:SetTexture("xBagSort","textures/config.png")
		--xbsinventory_configbutton:ResizeToTexture()
		xbsinventory_configbutton:SetPoint("BOTTOMRIGHT", xbsinventory_window,"BOTTOMRIGHT",-43,-9)
		xbsinventory_configbutton:SetLayer(3)
	local xbsinventory_closebutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsinventory_closebutton:SetVisible(false)
		xbsinventory_closebutton:SetTexture("xBagSort","textures/closebutton.png")
		--xbsinventory_closebutton:ResizeToTexture()
		xbsinventory_closebutton:SetPoint("TOPRIGHT", xbsinventory_window,"TOPRIGHT",-10,15)
		xbsinventory_closebutton:SetLayer(3)
	local xbsinventory_sortmethod=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsinventory_sortmethod:SetVisible(false)
		xbsinventory_sortmethod:SetItems({"Name","Type","Rarity","Auction House","Condense", "Quantity"})
		xbsinventory_sortmethod:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",110,65)
		xbsinventory_sortmethod:SetLayer(6)
		xbsinventory_sortmethod:SetSelectedIndex(1, true)
		xbsinventory_sortmethod:ResizeToFit()
		--xbsinventory_sortmethod:SetWidth(75)
		xbsinventory_sortmethod:SetBorder(1,1,1,1,1)
		xbsinventory_sortmethod.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  inv_settings[1]=self:GetSelectedItem()
			end
	local xbsinventory_order=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsinventory_order:SetVisible(false)
		xbsinventory_order:SetItems({"A -> Z", "Z -> A"})
		xbsinventory_order:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",75,150)
		xbsinventory_order:SetLayer(5)
		xbsinventory_order:SetSelectedIndex(1, true)
		xbsinventory_order:ResizeToFit()
		--xbsinventory_order:SetWidth(200)
		xbsinventory_order:SetBorder(1,1,1,1,1)
		xbsinventory_order.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  inv_settings[3]=self:GetSelectedItem()
			end
	local xbsinventory_placement=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsinventory_placement:SetVisible(false)
		xbsinventory_placement:SetItems({"Items First","Empty First"})
		xbsinventory_placement:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",200,150)
		xbsinventory_placement:SetLayer(5)
		xbsinventory_placement:SetSelectedIndex(1, true)
		xbsinventory_placement:ResizeToFit()
		--xbsinventory_placement:SetWidth(200)
		xbsinventory_placement:SetBorder(1,1,1,1,1)
		xbsinventory_placement.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  inv_settings[4]=self:GetSelectedItem()
			end
	local xbsinventory_speed=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsinventory_speed:SetVisible(false)
		xbsinventory_speed:SetItems({"-9 (Fastest)","-8","-7","-6","-5","-4","-3","-2","-1","Normal","+1","+2","+3","+4","+5","+6","+7","+8","+9 (Slowest)"})
		xbsinventory_speed:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",100,185)
		xbsinventory_speed:SetLayer(4)
		xbsinventory_speed:SetSelectedIndex(1, true)
		xbsinventory_speed:ResizeToFit()
		--xbsinventory_placement:SetWidth(200)
		xbsinventory_speed:SetBorder(1,1,1,1,1)
		xbsinventory_speed.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  inv_settings[5]=self:GetSelectedItem()
			end
	local xbsinventory_check1 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check1:SetVisible(false)
		xbsinventory_check1:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",90,115)
		xbsinventory_check1:SetLayer(3)
		function xbsinventory_check1.Event:CheckboxChange ()
			inv_settings[2][1]=self:GetChecked()
		end
	local xbsinventory_check2 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check2:SetVisible(false)
		xbsinventory_check2:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",110,115)
		xbsinventory_check2:SetLayer(3)
		function xbsinventory_check2.Event:CheckboxChange ()
			inv_settings[2][2]=self:GetChecked()
		end
	local xbsinventory_check3 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check3:SetVisible(false)
		xbsinventory_check3:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",130,115)
		xbsinventory_check3:SetLayer(3)
		function xbsinventory_check3.Event:CheckboxChange ()
			inv_settings[2][3]=self:GetChecked()
		end
	local xbsinventory_check4 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check4:SetVisible(false)
		xbsinventory_check4:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",150,115)
		xbsinventory_check4:SetLayer(3)
		function xbsinventory_check4.Event:CheckboxChange ()
			inv_settings[2][4]=self:GetChecked()
		end
	local xbsinventory_check5 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check5:SetVisible(false)
		xbsinventory_check5:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",170,115)
		xbsinventory_check5:SetLayer(3)
		function xbsinventory_check5.Event:CheckboxChange ()
			inv_settings[2][5]=self:GetChecked()
		end
	local xbsinventory_check6 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check6:SetVisible(false)
		xbsinventory_check6:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",190,115)
		xbsinventory_check6:SetLayer(3)
		function xbsinventory_check6.Event:CheckboxChange ()
			inv_settings[2][6]=self:GetChecked()
		end
	local xbsinventory_check7 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_check7:SetVisible(false)
		xbsinventory_check7:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",210,115)
		xbsinventory_check7:SetLayer(3)
		function xbsinventory_check7.Event:CheckboxChange ()
			inv_settings[2][7]=self:GetChecked()
		end
	local xbsinventory_auto = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsinventory_auto:SetVisible(false)
		xbsinventory_auto:SetPoint("TOPLEFT", xbsinventory_window,"TOPLEFT",90,220)
		xbsinventory_auto:SetLayer(3)
		function xbsinventory_auto.Event:CheckboxChange ()

		end
		
	local xbsinventory_sortnow= UI.CreateFrame("RiftButton","XBS",context)
		xbsinventory_sortnow:SetVisible(false)
		xbsinventory_sortnow:SetText("Sort Now")
		xbsinventory_sortnow:SetPoint("BOTTOMCENTER", xbsinventory_window,"BOTTOMCENTER",0,-10)
		xbsinventory_sortnow:SetLayer(3)
	local xbsinventory_close= UI.CreateFrame("RiftButton","XBS",context)
		xbsinventory_close:SetVisible(false)
		xbsinventory_close:SetText("Close")
		xbsinventory_close:SetPoint("BOTTOMCENTER", xbsinventory_window,"BOTTOMCENTER",0,-25)
		xbsinventory_close:SetLayer(3)
	
	function xbsbutton.Event:LeftPress ()
		xbsbutton:SetVisible(false)
		xbswindow:SetVisible(false)
		xbstext:SetVisible(false) 
	end
	function xbsinventory_button.Event:RightClick ()
		xbs_sort_now("inv","-echo")		
		
	end
function xbsinventory_helpbutton.Event:MouseIn(self)
	xbsinventory_helpbutton:SetTexture("xBagSort","textures/helpbutton_highlight.png")
	
end
function xbsinventory_helpbutton.Event:MouseOut()
	xbsinventory_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
	
end
function xbsinventory_helpbutton.Event:LeftDown(self)
	
	xbsinventory_helpbutton:SetTexture("xBagSort","textures/helpbutton_pressed.png")
end

	xbsinventory_closebutton:SetVisible(false)
function xbsinventory_helpbutton.Event:LeftUp()
	xbsinventory_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
	if(xbsbutton:GetVisible())then
		xbsbutton:SetVisible(false)
		xbswindow:SetVisible(false)
		xbstext:SetVisible(false)
		xbstext:SetText(help_text)
		xbstext:SetVisible(false) 
		-- Change the dimensions so all text is visible --
		xbstext:SetWidth(xbstext:GetWidth())
		xbstext:SetHeight(xbstext:GetHeight())
		xbswindow:SetWidth(xbstext:GetWidth()+100)	
		xbswindow:SetHeight(xbstext:GetHeight()+100)		
	else
		xbsbutton:SetVisible(true)
		xbswindow:SetVisible(true)
		xbstext:SetVisible(true)
		xbstext:SetText(invhelp_text)
		-- Change the dimensions so all text is visible --
		xbstext:SetWidth(xbstext:GetWidth())
		xbstext:SetHeight(xbstext:GetHeight())
		xbswindow:SetWidth(xbstext:GetWidth()+100)
		xbswindow:SetHeight(xbstext:GetHeight()+100)
	end
end

function xbsinventory_lockbutton.Event:MouseIn(self)
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7].."_highlight.png")
	
end
function xbsinventory_lockbutton.Event:MouseOut()
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7]..".png")
	
end
function xbsinventory_lockbutton.Event:LeftDown(self)
	
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7].."_pressed.png")
end
function xbsinventory_lockbutton.Event:LeftUp()
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7]..".png")
	if(invui=="locked")then
		inv_settings[7]="unlocked"
		invui=true
	else
		inv_settings[7]="locked"
		invui="locked"
	end
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7]..".png")
end



function xbsinventory_configbutton.Event:MouseIn(self)
	xbsinventory_configbutton:SetTexture("xBagSort","textures/config_highlight.png")
	
end
function xbsinventory_configbutton.Event:MouseOut()
	xbsinventory_configbutton:SetTexture("xBagSort","textures/config.png")
	
end
function xbsinventory_configbutton.Event:LeftDown(self)
	
	xbsinventory_configbutton:SetTexture("xBagSort","textures/config_pressed.png")
end
function xbsinventory_configbutton.Event:LeftUp()
	xbsinventory_configbutton:SetTexture("xBagSort","textures/config.png")
	xbs_setup()
end


function xbsinventory_closebutton.Event:MouseIn(self)
	xbsinventory_closebutton:SetTexture("xBagSort","textures/closebutton_highlight.png")
	
end
function xbsinventory_closebutton.Event:MouseOut()
	xbsinventory_closebutton:SetTexture("xBagSort","textures/closebutton.png")
	
end
function xbsinventory_closebutton.Event:LeftDown(self)
	
	xbsinventory_closebutton:SetTexture("xBagSort","textures/closebutton_pressed.png")
end

	xbsinventory_closebutton:SetVisible(false)
function xbsinventory_closebutton.Event:LeftUp()
	xbsinventory_closebutton:SetTexture("xBagSort","textures/closebutton.png")
	xbsinventory_window:SetVisible(false)
	xbsinventory_text:SetVisible(false)
	xbsinventory_sortmethod:SetVisible(false)
	xbsinventory_order:SetVisible(false)
	xbsinventory_placement:SetVisible(false)
	xbsinventory_speed:SetVisible(false)
	xbsinventory_check1:SetVisible(false)
	xbsinventory_check2:SetVisible(false)
	xbsinventory_check3:SetVisible(false)
	xbsinventory_check4:SetVisible(false)
	xbsinventory_check5:SetVisible(false)
	xbsinventory_check6:SetVisible(false)
	xbsinventory_check7:SetVisible(false)
	xbsinventory_auto:SetVisible(false)
	xbsinventory_sortnow:SetVisible(false)
	xbsinventory_close:SetVisible(false)
	xbsinventory_helpbutton:SetVisible(false)
	xbsinventory_closebutton:SetVisible(false)
	xbsinventory_lockbutton:SetVisible(false)
	xbsinventory_configbutton:SetVisible(false)
	xbsinventory_button:SetVisible(true)
	if(xbsinventory_auto:GetChecked()==true)then
		local query=""
		if(inv_settings[1]=="Type")then query=query.."type"
		elseif(inv_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..inv_settings[1] end
		if(inv_settings[2][1]==false)then query=query.."ignore01" end
		if(inv_settings[2][2]==false)then query=query.."ignore02" end
		if(inv_settings[2][3]==false)then query=query.."ignore03" end
		if(inv_settings[2][4]==false)then query=query.."ignore04" end
		if(inv_settings[2][5]==false)then query=query.."ignore05" end
		if(inv_settings[2][6]==false)then query=query.."ignore06" end
		if(inv_settings[2][7]==false)then query=query.."ignore07" end
		if(inv_settings[3]=="Z -> A")then query=query.."-i" end
		if(inv_settings[4]=="Empty First")then query=query.."-r" end
		if(inv_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(inv_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(inv_settings[5]=="Normal"))then query=query..inv_settings[5]end
		
		autosort=query
		print("Auto-sorting enabled using : "..autosort)
		print("Initial sorting commencing...")
		xbscommands(query)
	else
		autosort=nil
	end
end 
function UI.Native.BagInventory1.Event:Loaded()
	--print("bag event")
	if(UI.Native.BagInventory1:GetLoaded()==true and not(autosort==nil) and xbsbankqueue=="inventory")then
	
			local c=autosort.."-echo"
			
			xbscommands(c)
		
	end
	if(UI.Native.BagInventory1:GetLoaded()==true and invui=="locked")then
		xbsinventory_button.Event:LeftUp()
	elseif(UI.Native.BagInventory1:GetLoaded()==true and invui==true)then
		--print("should be showing")
		xbsinventory_button:SetVisible(true)
	end
	if(UI.Native.BagInventory1:GetLoaded()==false)then
		xbsinventory_button:SetVisible(false)
		xbsinventory_window:SetVisible(false)
		xbsinventory_text:SetVisible(false)
		xbsinventory_sortmethod:SetVisible(false)
		xbsinventory_order:SetVisible(false)
		xbsinventory_placement:SetVisible(false)
		xbsinventory_speed:SetVisible(false)
		xbsinventory_check1:SetVisible(false)
		xbsinventory_check2:SetVisible(false)
		xbsinventory_check3:SetVisible(false)
		xbsinventory_check4:SetVisible(false)
		xbsinventory_check5:SetVisible(false)
		xbsinventory_check6:SetVisible(false)
		xbsinventory_check7:SetVisible(false)
		xbsinventory_auto:SetVisible(false)
		xbsinventory_sortnow:SetVisible(false)
		xbsinventory_close:SetVisible(false)
		xbsinventory_helpbutton:SetVisible(false)
		xbsinventory_closebutton:SetVisible(false)
		xbsinventory_lockbutton:SetVisible(false)
		xbsinventory_configbutton:SetVisible(false)
		if(xbsinventory_auto:GetChecked()==true)then
			local query=""
			if(inv_settings[1]=="Type")then query=query.."type"
			elseif(inv_settings[1]=="Auction House")then query=query.."ah"
			
			else query=query..inv_settings[1] end
			if(inv_settings[2][1]==false)then query=query.."ignore01" end
			if(inv_settings[2][2]==false)then query=query.."ignore02" end
			if(inv_settings[2][3]==false)then query=query.."ignore03" end
			if(inv_settings[2][4]==false)then query=query.."ignore04" end
			if(inv_settings[2][5]==false)then query=query.."ignore05" end
			if(inv_settings[2][6]==false)then query=query.."ignore06" end
			if(inv_settings[2][7]==false)then query=query.."ignore07" end
			if(inv_settings[3]=="Z -> A")then query=query.."-i" end
			if(inv_settings[4]=="Empty First")then query=query.."-r" end
			if(inv_settings[5]=="-9 (Fastest)")then query=query.."-9"
			elseif(inv_settings[5]=="+9 (Slowest)")then query=query.."+9"
			elseif(not(inv_settings[5]=="Normal"))then query=query..inv_settings[5]end
			query=query.."-echo"
			autosort=query
			xbscommands(query)
		else
			autosort=nil
		end
	end
	
	
end
function xbsinventory_sortnow.Event:LeftPress ()
	xbs_sort_now("inv","-echo")
	
end

function xbsinventory_button.Event:MouseIn(self)
	if(inv_settings[6]=="TOPLEFT" or inv_settings[6]=="TOPCENTER" or inv_settings[6]=="TOPRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top_highlight.png")
	elseif(inv_settings[6]=="BOTTOMLEFT" or inv_settings[6]=="BOTTOMCENTER" or inv_settings[6]=="BOTTOMRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom_highlight.png")
	elseif(inv_settings[6]=="LEFTTOP" or inv_settings[6]=="CENTERLEFT" or inv_settings[6]=="LEFTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left_highlight.png")
	elseif(inv_settings[6]=="RIGHTTOP" or inv_settings[6]=="CENTERRIGHT" or inv_settings[6]=="RIGHTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right_highlight.png")
	end
end
function xbsinventory_button.Event:MouseOut()
	
	if(inv_settings[6]=="TOPLEFT" or inv_settings[6]=="TOPCENTER" or inv_settings[6]=="TOPRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top.png")
	elseif(inv_settings[6]=="BOTTOMLEFT" or inv_settings[6]=="BOTTOMCENTER" or inv_settings[6]=="BOTTOMRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom.png")
	elseif(inv_settings[6]=="LEFTTOP" or inv_settings[6]=="CENTERLEFT" or inv_settings[6]=="LEFTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left.png")
	elseif(inv_settings[6]=="RIGHTTOP" or inv_settings[6]=="CENTERRIGHT" or inv_settings[6]=="RIGHTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right.png")
	end
end
function xbsinventory_button.Event:LeftDown(self)
	if(inv_settings[6]=="TOPLEFT" or inv_settings[6]=="TOPCENTER" or inv_settings[6]=="TOPRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top_pressed.png")
	elseif(inv_settings[6]=="BOTTOMLEFT" or inv_settings[6]=="BOTTOMCENTER" or inv_settings[6]=="BOTTOMRIGHT")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom_pressed.png")
	elseif(inv_settings[6]=="LEFTTOP" or inv_settings[6]=="CENTERLEFT" or inv_settings[6]=="LEFTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left_pressed.png")
	elseif(inv_settings[6]=="RIGHTTOP" or inv_settings[6]=="CENTERRIGHT" or inv_settings[6]=="RIGHTBOTTOM")then 
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right_pressed.png")
	end
end

function xbsinventory_button.Event:LeftUp()
	xbsinventory_window:SetVisible(true)
	xbsinventory_text:SetVisible(true)
	xbsinventory_sortmethod:SetVisible(true)
	xbsinventory_order:SetVisible(true)
	xbsinventory_placement:SetVisible(true)
	xbsinventory_speed:SetVisible(true)
	xbsinventory_check1:SetVisible(true)
	xbsinventory_check2:SetVisible(true)
	xbsinventory_check3:SetVisible(true)
	xbsinventory_check4:SetVisible(true)
	xbsinventory_check5:SetVisible(true)
	xbsinventory_check6:SetVisible(true)
	xbsinventory_check7:SetVisible(true)
	xbsinventory_auto:SetVisible(true)
	xbsinventory_sortnow:SetVisible(true)
	
	--xbsinventory_close:SetVisible(true)
	xbsinventory_helpbutton:SetVisible(true)
	xbsinventory_closebutton:SetVisible(true)
	
	xbsinventory_lockbutton:SetVisible(true)
	xbsinventory_lockbutton:SetTexture("xBagSort","textures/"..inv_settings[7]..".png")
	xbsinventory_configbutton:SetVisible(true)
	xbsinventory_button:SetVisible(false)
end

function xbsinventory_close.Event:LeftPress ()
	xbsinventory_window:SetVisible(false)
	xbsinventory_text:SetVisible(false)
	xbsinventory_sortmethod:SetVisible(false)
	xbsinventory_order:SetVisible(false)
	xbsinventory_placement:SetVisible(false)
	xbsinventory_speed:SetVisible(false)
	xbsinventory_check1:SetVisible(false)
	xbsinventory_check2:SetVisible(false)
	xbsinventory_check3:SetVisible(false)
	xbsinventory_check4:SetVisible(false)
	xbsinventory_check5:SetVisible(false)
	xbsinventory_check6:SetVisible(false)
	xbsinventory_check7:SetVisible(false)
	xbsinventory_auto:SetVisible(false)
	xbsinventory_sortnow:SetVisible(false)
	xbsinventory_close:SetVisible(false)
	xbsinventory_lockbutton:SetVisible(false)
	xbsinventory_configbutton:SetVisible(false)
	xbsinventory_helpbutton:SetVisible(false)
	xbsinventory_closebutton:SetVisible(false)
	xbsinventory_button:SetVisible(true)
	
	if(xbsinventory_auto:GetChecked()==true)then
		local query=""
		if(inv_settings[1]=="Type")then query=query.."type"
		elseif(inv_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..inv_settings[1] end
		if(inv_settings[2][1]==false)then query=query.."ignore01" end
		if(inv_settings[2][2]==false)then query=query.."ignore02" end
		if(inv_settings[2][3]==false)then query=query.."ignore03" end
		if(inv_settings[2][4]==false)then query=query.."ignore04" end
		if(inv_settings[2][5]==false)then query=query.."ignore05" end
		if(inv_settings[2][6]==false)then query=query.."ignore06" end
		if(inv_settings[2][7]==false)then query=query.."ignore07" end
		if(inv_settings[3]=="Z -> A")then query=query.."-i" end
		if(inv_settings[4]=="Empty First")then query=query.."-r" end
		if(inv_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(inv_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(inv_settings[5]=="Normal"))then query=query..inv_settings[5]end
		
		autosort=query
		print("Auto-sorting enabled using : "..autosort)
		print("Initial sorting commencing...")
		xbscommands(query)
	else
		autosort=nil
	end
	
end
local function xbs_inventory_window_placement()
	if(inv_settings[6]=="TOPLEFT" or inv_settings[6]=="TOPCENTER" or inv_settings[6]=="TOPRIGHT")then 
		xbsinventory_window:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPLEFT",(xbsinventory_text:GetWidth()+125)*-0.5,(xbsinventory_text:GetHeight()+75)*-1)
	elseif(inv_settings[6]=="BOTTOMLEFT" or inv_settings[6]=="BOTTOMCENTER" or inv_settings[6]=="BOTTOMRIGHT")then 
		xbsinventory_window:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMCENTER",(xbsinventory_text:GetWidth()+125)*-0.5,-10)
	elseif(inv_settings[6]=="LEFTTOP" or inv_settings[6]=="CENTERLEFT" or inv_settings[6]=="LEFTBOTTOM")then 
		xbsinventory_window:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPLEFT",(xbsinventory_text:GetWidth()+125)*-1,-10)
	elseif(inv_settings[6]=="RIGHTTOP" or inv_settings[6]=="CENTERRIGHT" or inv_settings[6]=="RIGHTBOTTOM")then 
		xbsinventory_window:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPRIGHT",0,-10)
	end
end
local function xbs_inventory_button_placement()
	xbsinventory_button:SetVisible(false)
	if(inv_settings[6]=="TOPLEFT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPLEFT",20,-23)
		
	elseif(inv_settings[6]=="TOPCENTER")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPCENTER",-32,-23)
	elseif(inv_settings[6]=="TOPRIGHT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPRIGHT",-90,-23)
	elseif(inv_settings[6]=="BOTTOMLEFT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMLEFT",0,-10)
	elseif(inv_settings[6]=="BOTTOMCENTER")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMCENTER",-32,-10)
	elseif(inv_settings[6]=="BOTTOMRIGHT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMRIGHT",-74,-10)
	elseif(inv_settings[6]=="RIGHTTOP")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPRIGHT",-10,20)
	elseif(inv_settings[6]=="CENTERRIGHT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"CENTERRIGHT",-10,-37)
	elseif(inv_settings[6]=="RIGHTBOTTOM")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMRIGHT",-10,-74)
	elseif(inv_settings[6]=="LEFTTOP")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"TOPLEFT",-19,20)
	elseif(inv_settings[6]=="CENTERLEFT")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"CENTERLEFT",-19,-37)
	elseif(inv_settings[6]=="LEFTBOTTOM")then
		xbsinventory_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsinventory_button:ResizeToTexture()
		xbsinventory_button:SetPoint("TOPLEFT", UI.Native.BagInventory1,"BOTTOMLEFT",-19,-74)
	end
	--xbsinventory_button:SetVisible(true)
	xbsinventory_button:SetLayer(3)
	xbs_inventory_window_placement()
end


-- Bank UI
local xbsbank_button=UI.CreateFrame("Texture","xBagSort",context)
		xbsbank_button:SetVisible(false)
		-- xbsinventory_button:SetText("XBS")
		-- xbsinventory_button:SetPoint("BOTTOMCENTER", UI.Native.BagInventory1,"BOTTOMCENTER",0,20)
		-- xbsinventory_button:SetLayer(2)
	local xbsbank_window= UI.CreateFrame("RiftWindow","xBagSort",context)
		xbsbank_window:SetVisible(false)
		xbsbank_window:SetTitle("xBagSort")
		--xbsinventory_window:SetPoint("BOTTOMLEFT", UI.Native.BagInventory1,"BOTTOMLEFT",0,0)
		xbsbank_window:SetLayer(2)
		xbsbank_window:SetHeight(375)
	
	local xbsbank_text= UI.CreateFrame("Text","xBagSort",context)
		xbsbank_text:SetVisible(false)
local xbsbtext="Sort Method:\
\
		Main Vault    Bags:  1    2   3    4   5   6    7   8\
Sort Bag:\
		Vaults:  2    3    4   5   6    7   \
\
\
Order:  		       Placement:\
\
Sort Speed:\
\
Auto Sort:\
\
\
\
\
"..xbsversion
		xbsbank_text:SetText(xbsbtext)
		xbsbank_text:SetWidth(xbsbank_text:GetWidth())
		xbsbank_text:SetHeight(xbsbank_text:GetHeight())
		--xbswindow:SetWidth(xbstext:GetWidth()+100)
		 
		-- Put it at the top c	enter of the game --
		xbsbank_window:SetWidth(xbsbank_text:GetWidth()+50)
		--xbsbank_window:SetPoint("BOTTOMLEFT", UI.Native.Bank,"BOTTOMLEFT",(xbsbank_text:GetWidth()+125)*-1,0)
		xbsbank_text:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",25,65)
		--xbsbank_text:SetPoint("BOTTOMCENTER", UI.Native.Bank,"BOTTOMCENTER",0,15)
		xbsbank_text:SetLayer(3)
	local xbsbank_helpbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsbank_helpbutton:SetVisible(false)
		xbsbank_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
		--xbsbank_helpbutton:ResizeToTexture()
		xbsbank_helpbutton:SetPoint("BOTTOMRIGHT", xbsbank_window,"BOTTOMRIGHT",-10,-10)
		xbsbank_helpbutton:SetLayer(3)
	local xbsbank_lockbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsbank_lockbutton:SetVisible(false)
		xbsbank_lockbutton:SetTexture("xBagSort","textures/unlocked.png")
		--xbsbank_lockbutton:ResizeToTexture()
		xbsbank_lockbutton:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",10,15)
		xbsbank_lockbutton:SetLayer(3)
	local xbsbank_configbutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsbank_configbutton:SetVisible(false)
		xbsbank_configbutton:SetTexture("xBagSort","textures/config.png")
		--xbsbank_configbutton:ResizeToTexture()
		xbsbank_configbutton:SetPoint("BOTTOMRIGHT", xbsbank_window,"BOTTOMRIGHT",-43,-9)
		xbsbank_configbutton:SetLayer(3)
	local xbsbank_closebutton=UI.CreateFrame("Texture","xBagSort",context)
		xbsbank_closebutton:SetVisible(false)
		xbsbank_closebutton:SetTexture("xBagSort","textures/closebutton.png")
		--xbsbank_closebutton:ResizeToTexture()
		xbsbank_closebutton:SetPoint("TOPRIGHT", xbsbank_window,"TOPRIGHT",-10,15)
		xbsbank_closebutton:SetLayer(3)
	local xbsbank_sortmethod=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsbank_sortmethod:SetVisible(false)
		xbsbank_sortmethod:SetItems({"Name","Type","Rarity","Auction House","Condense", "Quantity"})
		xbsbank_sortmethod:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",110,65)
		xbsbank_sortmethod:SetLayer(6)
		xbsbank_sortmethod:SetSelectedIndex(1, true)
		xbsbank_sortmethod:ResizeToFit()
		--xbsbank_sortmethod:SetWidth(75)
		xbsbank_sortmethod:SetBorder(1,1,1,1,1)
		xbsbank_sortmethod.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  bank_settings[1]=self:GetSelectedItem()
			end
	local xbsbank_order=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsbank_order:SetVisible(false)
		xbsbank_order:SetItems({"A -> Z", "Z -> A"})
		xbsbank_order:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",75,185)
		xbsbank_order:SetLayer(5)
		xbsbank_order:SetSelectedIndex(1, true)
		xbsbank_order:ResizeToFit()
		--xbsbank_order:SetWidth(200)
		xbsbank_order:SetBorder(1,1,1,1,1)
		xbsbank_order.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  bank_settings[3]=self:GetSelectedItem()
			end
	local xbsbank_placement=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsbank_placement:SetVisible(false)
		xbsbank_placement:SetItems({"Items First","Empty First"})
		xbsbank_placement:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",210,185)
		xbsbank_placement:SetLayer(5)
		xbsbank_placement:SetSelectedIndex(1, true)
		xbsbank_placement:ResizeToFit()
		--xbsbank_placement:SetWidth(200)
		xbsbank_placement:SetBorder(1,1,1,1,1)
		xbsbank_placement.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  bank_settings[4]=self:GetSelectedItem()
			end
	local xbsbank_speed=UI.CreateFrame("SimpleSelect","XBS",context)
		xbsbank_speed:SetVisible(false)
		xbsbank_speed:SetItems({"-9 (Fastest)","-8","-7","-6","-5","-4","-3","-2","-1","Normal","+1","+2","+3","+4","+5","+6","+7","+8","+9 (Slowest)"})
		xbsbank_speed:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",100,220)
		xbsbank_speed:SetLayer(4)
		xbsbank_speed:SetSelectedIndex(1, true)
		xbsbank_speed:ResizeToFit()
		--xbsbank_placement:SetWidth(200)
		xbsbank_speed:SetBorder(1,1,1,1,1)
		xbsbank_speed.Event.ItemSelect = function(self)
			  --print(self:GetSelectedItem().." selected")
			  bank_settings[5]=self:GetSelectedItem()
			end
	local xbsbank_check1 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check1:SetVisible(false)
		xbsbank_check1:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",115,115)
		xbsbank_check1:SetLayer(3)
		function xbsbank_check1.Event:CheckboxChange ()
			bank_settings[2][1]=self:GetChecked()
		end
	local xbsbank_check2 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check2:SetVisible(false)
		xbsbank_check2:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",195,115)
		xbsbank_check2:SetLayer(3)
		function xbsbank_check2.Event:CheckboxChange ()
			bank_settings[2][2]=self:GetChecked()
		end
	local xbsbank_check3 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check3:SetVisible(false)
		xbsbank_check3:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",215,115)
		xbsbank_check3:SetLayer(3)
		function xbsbank_check3.Event:CheckboxChange ()
			bank_settings[2][3]=self:GetChecked()
		end
	local xbsbank_check4 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check4:SetVisible(false)
		xbsbank_check4:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",235,115)
		xbsbank_check4:SetLayer(3)
		function xbsbank_check4.Event:CheckboxChange ()
			bank_settings[2][4]=self:GetChecked()
		end
	local xbsbank_check5 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check5:SetVisible(false)
		xbsbank_check5:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",255,115)
		xbsbank_check5:SetLayer(3)
		function xbsbank_check5.Event:CheckboxChange ()
			bank_settings[2][5]=self:GetChecked()
		end
	local xbsbank_check6 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check6:SetVisible(false)
		xbsbank_check6:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",275,115)
		xbsbank_check6:SetLayer(3)
		function xbsbank_check6.Event:CheckboxChange ()
			bank_settings[2][6]=self:GetChecked()
		end
	local xbsbank_check7 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check7:SetVisible(false)
		xbsbank_check7:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",295,115)
		xbsbank_check7:SetLayer(3)
		function xbsbank_check7.Event:CheckboxChange ()
			bank_settings[2][7]=self:GetChecked()
		end
	local xbsbank_check8 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check8:SetVisible(false)
		xbsbank_check8:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",315,115)
		xbsbank_check8:SetLayer(3)
		function xbsbank_check8.Event:CheckboxChange ()
			bank_settings[2][8]=self:GetChecked()
		end
	local xbsbank_check9 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check9:SetVisible(false)
		xbsbank_check9:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",335,115)
		xbsbank_check9:SetLayer(3)
		function xbsbank_check9.Event:CheckboxChange ()
			bank_settings[2][9]=self:GetChecked()
		end
	local xbsbank_check10 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check10:SetVisible(false)
		xbsbank_check10:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",135,150)
		xbsbank_check10:SetLayer(3)
		function xbsbank_check10.Event:CheckboxChange ()
			bank_settings[2][10]=self:GetChecked()
		end
	local xbsbank_check11 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check11:SetVisible(false)
		xbsbank_check11:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",155,150)
		xbsbank_check11:SetLayer(3)
		function xbsbank_check11.Event:CheckboxChange ()
			bank_settings[2][11]=self:GetChecked()
		end
	local xbsbank_check12 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check12:SetVisible(false)
		xbsbank_check12:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",175,150)
		xbsbank_check12:SetLayer(3)
		function xbsbank_check12.Event:CheckboxChange ()
			bank_settings[2][12]=self:GetChecked()
		end
	local xbsbank_check13 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check13:SetVisible(false)
		xbsbank_check13:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",195,150)
		xbsbank_check13:SetLayer(3)
		function xbsbank_check13.Event:CheckboxChange ()
			bank_settings[2][13]=self:GetChecked()
		end
	local xbsbank_check14 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check14:SetVisible(false)
		xbsbank_check14:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",215,150)
		xbsbank_check14:SetLayer(3)
		function xbsbank_check14.Event:CheckboxChange ()
			bank_settings[2][14]=self:GetChecked()
		end
	local xbsbank_check15 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check15:SetVisible(false)
		xbsbank_check15:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",235,150)
		xbsbank_check15:SetLayer(3)
		function xbsbank_check15.Event:CheckboxChange ()
			bank_settings[2][15]=self:GetChecked()
		end
	--[[local xbsbank_check16 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check16:SetVisible(false)
		xbsbank_check16:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",255,150)
		xbsbank_check16:SetLayer(3)
		function xbsbank_check16.Event:CheckboxChange ()
			bank_settings[2][16]=self:GetChecked()
		end--]]
	--[[local xbsbank_check17 = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_check17:SetVisible(false)
		xbsbank_check17:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",270,150)
		xbsbank_check17:SetLayer(3)
		function xbsbank_check17.Event:CheckboxChange ()
			bank_settings[2][17]=self:GetChecked()
		end--]]
	local xbsbank_auto = UI.CreateFrame("RiftCheckbox", "Check1", context)
		xbsbank_auto:SetVisible(false)
		xbsbank_auto:SetPoint("TOPLEFT", xbsbank_window,"TOPLEFT",90,255)
		xbsbank_auto:SetLayer(3)
		function xbsbank_auto.Event:CheckboxChange ()

		end
		
	local xbsbank_sortnow= UI.CreateFrame("RiftButton","XBS",context)
		xbsbank_sortnow:SetVisible(false)
		xbsbank_sortnow:SetText("Sort Now")
		xbsbank_sortnow:SetPoint("BOTTOMCENTER", xbsbank_window,"BOTTOMCENTER",0,-10)
		xbsbank_sortnow:SetLayer(3)
	local xbsbank_close= UI.CreateFrame("RiftButton","XBS",context)
		xbsbank_close:SetVisible(false)
		xbsbank_close:SetText("Close")
		xbsbank_close:SetPoint("BOTTOMCENTER", xbsbank_window,"BOTTOMCENTER",0,-25)
		xbsbank_close:SetLayer(3)
	
	function xbsbutton.Event:LeftPress ()
		xbsbutton:SetVisible(false)
		xbswindow:SetVisible(false)
		xbstext:SetVisible(false) 
	end
function xbsbank_helpbutton.Event:MouseIn(self)
	xbsbank_helpbutton:SetTexture("xBagSort","textures/helpbutton_highlight.png")
	
end
function xbsbank_helpbutton.Event:MouseOut()
	xbsbank_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
	
end
function xbsbank_helpbutton.Event:LeftDown(self)
	
	xbsbank_helpbutton:SetTexture("xBagSort","textures/helpbutton_pressed.png")
end

	xbsbank_closebutton:SetVisible(false)
function xbsbank_helpbutton.Event:LeftUp()
	xbsbank_helpbutton:SetTexture("xBagSort","textures/helpbutton.png")
	if(xbsbutton:GetVisible())then
		xbsbutton:SetVisible(false)
		xbswindow:SetVisible(false)
		xbstext:SetVisible(false)
		xbstext:SetText(help_text)
		xbstext:SetVisible(false) 
		-- Change the dimensions so all text is visible --
		xbstext:SetWidth(xbstext:GetWidth())
		xbstext:SetHeight(xbstext:GetHeight())
		xbswindow:SetWidth(xbstext:GetWidth()+100)	
		xbswindow:SetHeight(xbstext:GetHeight()+100)		
	else
		xbsbutton:SetVisible(true)
		xbswindow:SetVisible(true)
		xbstext:SetVisible(true)
		xbstext:SetText(invhelp_text)
		-- Change the dimensions so all text is visible --
		xbstext:SetWidth(xbstext:GetWidth())
		xbstext:SetHeight(xbstext:GetHeight())
		xbswindow:SetWidth(xbstext:GetWidth()+100)
		xbswindow:SetHeight(xbstext:GetHeight()+100)
	end
end

function xbsbank_lockbutton.Event:MouseIn(self)
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7].."_highlight.png")
	
end
function xbsbank_lockbutton.Event:MouseOut()
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7]..".png")
	
end
function xbsbank_lockbutton.Event:LeftDown(self)
	
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7].."_pressed.png")
end
function xbsbank_lockbutton.Event:LeftUp()
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7]..".png")
	if(bankui=="locked")then
		bank_settings[7]="unlocked"
		bankui=true
	else
		bank_settings[7]="locked"
		bankui="locked"
	end
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7]..".png")
end



function xbsbank_configbutton.Event:MouseIn(self)
	xbsbank_configbutton:SetTexture("xBagSort","textures/config_highlight.png")
	
end
function xbsbank_configbutton.Event:MouseOut()
	xbsbank_configbutton:SetTexture("xBagSort","textures/config.png")
	
end
function xbsbank_configbutton.Event:LeftDown(self)
	
	xbsbank_configbutton:SetTexture("xBagSort","textures/config_pressed.png")
end
function xbsbank_configbutton.Event:LeftUp()
	xbsbank_configbutton:SetTexture("xBagSort","textures/config.png")
	xbs_setup()
end


function xbsbank_closebutton.Event:MouseIn(self)
	xbsbank_closebutton:SetTexture("xBagSort","textures/closebutton_highlight.png")
	
end
function xbsbank_closebutton.Event:MouseOut()
	xbsbank_closebutton:SetTexture("xBagSort","textures/closebutton.png")
	
end
function xbsbank_closebutton.Event:LeftDown(self)
	
	xbsbank_closebutton:SetTexture("xBagSort","textures/closebutton_pressed.png")
end

	xbsbank_closebutton:SetVisible(false)
function xbsbank_closebutton.Event:LeftUp()
	xbsbank_closebutton:SetTexture("xBagSort","textures/closebutton.png")
	xbsbank_window:SetVisible(false)
	xbsbank_text:SetVisible(false)
	xbsbank_sortmethod:SetVisible(false)
	xbsbank_order:SetVisible(false)
	xbsbank_placement:SetVisible(false)
	xbsbank_speed:SetVisible(false)
	xbsbank_check1:SetVisible(false)
	xbsbank_check2:SetVisible(false)
	xbsbank_check3:SetVisible(false)
	xbsbank_check4:SetVisible(false)
	xbsbank_check5:SetVisible(false)
	xbsbank_check6:SetVisible(false)
	xbsbank_check7:SetVisible(false)
	xbsbank_check8:SetVisible(false)
	xbsbank_check9:SetVisible(false)
	xbsbank_check10:SetVisible(false)
	xbsbank_check11:SetVisible(false)
	xbsbank_check12:SetVisible(false)
	xbsbank_check13:SetVisible(false)
	xbsbank_check14:SetVisible(false)
	xbsbank_check15:SetVisible(false)
	--xbsbank_check16:SetVisible(false)
	--xbsbank_check17:SetVisible(false)
	xbsbank_auto:SetVisible(false)
	xbsbank_sortnow:SetVisible(false)
	xbsbank_close:SetVisible(false)
	xbsbank_helpbutton:SetVisible(false)
	xbsbank_closebutton:SetVisible(false)
	xbsbank_lockbutton:SetVisible(false)
	xbsbank_configbutton:SetVisible(false)
	xbsbank_button:SetVisible(true)
	if(xbsbank_auto:GetChecked()==true)then
		local query="bank"
		if(bank_settings[1]=="Type")then query=query.."type"
		elseif(bank_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..bank_settings[1] end
		if(bank_settings[2][1]==false)then query=query.."ignore01" end
		if(bank_settings[2][2]==false)then query=query.."ignore02" end
		if(bank_settings[2][3]==false)then query=query.."ignore03" end
		if(bank_settings[2][4]==false)then query=query.."ignore04" end
		if(bank_settings[2][5]==false)then query=query.."ignore05" end
		if(bank_settings[2][6]==false)then query=query.."ignore06" end
		if(bank_settings[2][7]==false)then query=query.."ignore07" end
		if(bank_settings[2][8]==false)then query=query.."ignore08" end
		if(bank_settings[2][9]==false)then query=query.."ignore09" end
		if(bank_settings[2][10]==false)then query=query.."ignore10" end
		if(bank_settings[2][11]==false)then query=query.."ignore11" end
		if(bank_settings[2][12]==false)then query=query.."ignore12" end
		if(bank_settings[2][13]==false)then query=query.."ignore13" end
		if(bank_settings[2][14]==false)then query=query.."ignore14" end
		if(bank_settings[2][15]==false)then query=query.."ignore15" end
		if(bank_settings[3]=="Z -> A")then query=query.."-i" end
		if(bank_settings[4]=="Empty First")then query=query.."-r" end
		if(bank_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(bank_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(bank_settings[5]=="Normal"))then query=query..bank_settings[5]end
		
		bankautosort=query
		print("Auto-sorting enabled using : "..bankautosort)
		print("Initial sorting commencing...")
		
		xbscommands(query)
	else
		bankautosort=nil
	end
end
function UI.Native.Bank.Event:Loaded()
	--print("bank event")
	if(UI.Native.Bank:GetLoaded()==true and not(bankautosort==nil))then
		local cc=bankautosort.."-echo"
		--print
		--print("Autosort = "..autosort)
			if(not(autosort==nil))then
				local c=autosort.."-echo"
				xbsbankqueue="inventory"
				xbscommands(c)
			else
			xbscommands(cc)
			end
		
	end
	if(UI.Native.Bank:GetLoaded()==true and bankui=="locked")then
		xbsbank_button.Event:LeftUp()
	elseif(UI.Native.Bank:GetLoaded()==true and bankui==true)then
		xbsbank_button:SetVisible(true)
	end
	if(UI.Native.Bank:GetLoaded()==false)then
		--print("bank closed")
		xbsbankqueue="off"
		xbsbank_button:SetVisible(false)
		xbsbank_window:SetVisible(false)
		xbsbank_text:SetVisible(false)
		xbsbank_sortmethod:SetVisible(false)
		xbsbank_order:SetVisible(false)
		xbsbank_placement:SetVisible(false)
		xbsbank_speed:SetVisible(false)
		xbsbank_check1:SetVisible(false)
		xbsbank_check2:SetVisible(false)
		xbsbank_check3:SetVisible(false)
		xbsbank_check4:SetVisible(false)
		xbsbank_check5:SetVisible(false)
		xbsbank_check6:SetVisible(false)
		xbsbank_check7:SetVisible(false)
		xbsbank_check8:SetVisible(false)
		xbsbank_check9:SetVisible(false)
		xbsbank_check10:SetVisible(false)
		xbsbank_check11:SetVisible(false)
		xbsbank_check12:SetVisible(false)
		xbsbank_check13:SetVisible(false)
		xbsbank_check14:SetVisible(false)
		xbsbank_check15:SetVisible(false)
		--xbsbank_check16:SetVisible(false)
		--xbsbank_check17:SetVisible(false)
		xbsbank_auto:SetVisible(false)
		xbsbank_sortnow:SetVisible(false)
		xbsbank_close:SetVisible(false)
		xbsbank_helpbutton:SetVisible(false)
		xbsbank_closebutton:SetVisible(false)
		xbsbank_lockbutton:SetVisible(false)
		xbsbank_configbutton:SetVisible(false)
		if(xbsbank_auto:GetChecked()==true)then
			local query="bank "
			if(bank_settings[1]=="Type")then query=query.."type"
			elseif(bank_settings[1]=="Auction House")then query=query.."ah"
			
			else query=query..bank_settings[1] end
			if(bank_settings[2][1]==false)then query=query.."ignore01" end
			if(bank_settings[2][2]==false)then query=query.."ignore02" end
			if(bank_settings[2][3]==false)then query=query.."ignore03" end
			if(bank_settings[2][4]==false)then query=query.."ignore04" end
			if(bank_settings[2][5]==false)then query=query.."ignore05" end
			if(bank_settings[2][6]==false)then query=query.."ignore06" end
			if(bank_settings[2][7]==false)then query=query.."ignore07" end
			if(bank_settings[2][8]==false)then query=query.."ignore08" end
			if(bank_settings[2][9]==false)then query=query.."ignore09" end
			if(bank_settings[2][10]==false)then query=query.."ignore10" end
			if(bank_settings[2][11]==false)then query=query.."ignore11" end
			if(bank_settings[2][12]==false)then query=query.."ignore12" end
			if(bank_settings[2][13]==false)then query=query.."ignore13" end
			if(bank_settings[2][14]==false)then query=query.."ignore14" end
			if(bank_settings[2][15]==false)then query=query.."ignore15" end
			if(bank_settings[3]=="Z -> A")then query=query.."-i" end
			if(bank_settings[4]=="Empty First")then query=query.."-r" end
			if(bank_settings[5]=="-9 (Fastest)")then query=query.."-9"
			elseif(bank_settings[5]=="+9 (Slowest)")then query=query.."+9"
			elseif(not(bank_settings[5]=="Normal"))then query=query..bank_settings[5]end
			query=query.."-echo"
			bankautosort=query

			xbscommands(query)
			
		else
			bankautosort=nil
		end
	end
	
	
end
function xbsbank_sortnow.Event:LeftPress ()
	xbs_sort_now("bank","-echo")
	
end

function xbsbank_button.Event:MouseIn(self)
	
	if(bank_settings[6]=="TOPLEFT" or bank_settings[6]=="TOPCENTER" or bank_settings[6]=="TOPRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top_highlight.png")
	elseif(bank_settings[6]=="BOTTOMLEFT" or bank_settings[6]=="BOTTOMCENTER" or bank_settings[6]=="BOTTOMRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom_highlight.png")
	elseif(bank_settings[6]=="LEFTTOP" or bank_settings[6]=="CENTERLEFT" or bank_settings[6]=="LEFTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left_highlight.png")
	elseif(bank_settings[6]=="RIGHTTOP" or bank_settings[6]=="CENTERRIGHT" or bank_settings[6]=="RIGHTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right_highlight.png")
	end
end
function xbsbank_button.Event:MouseOut()
	
	if(bank_settings[6]=="TOPLEFT" or bank_settings[6]=="TOPCENTER" or bank_settings[6]=="TOPRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top.png")
	elseif(bank_settings[6]=="BOTTOMLEFT" or bank_settings[6]=="BOTTOMCENTER" or bank_settings[6]=="BOTTOMRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom.png")
	elseif(bank_settings[6]=="LEFTTOP" or bank_settings[6]=="CENTERLEFT" or bank_settings[6]=="LEFTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left.png")
	elseif(bank_settings[6]=="RIGHTTOP" or bank_settings[6]=="CENTERRIGHT" or bank_settings[6]=="RIGHTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right.png")
	end
end
function xbsbank_button.Event:LeftDown(self)
	if(bank_settings[6]=="TOPLEFT" or bank_settings[6]=="TOPCENTER" or bank_settings[6]=="TOPRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top_pressed.png")
	elseif(bank_settings[6]=="BOTTOMLEFT" or bank_settings[6]=="BOTTOMCENTER" or bank_settings[6]=="BOTTOMRIGHT")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom_pressed.png")
	elseif(bank_settings[6]=="LEFTTOP" or bank_settings[6]=="CENTERLEFT" or bank_settings[6]=="LEFTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left_pressed.png")
	elseif(bank_settings[6]=="RIGHTTOP" or bank_settings[6]=="CENTERRIGHT" or bank_settings[6]=="RIGHTBOTTOM")then 
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right_pressed.png")
	end
end

function xbsbank_button.Event:LeftUp()
	xbsbank_window:SetVisible(true)
	xbsbank_text:SetVisible(true)
	xbsbank_sortmethod:SetVisible(true)
	xbsbank_order:SetVisible(true)
	xbsbank_placement:SetVisible(true)
	xbsbank_speed:SetVisible(true)
	xbsbank_check1:SetVisible(true)
	xbsbank_check2:SetVisible(true)
	xbsbank_check3:SetVisible(true)
	xbsbank_check4:SetVisible(true)
	xbsbank_check5:SetVisible(true)
	xbsbank_check6:SetVisible(true)
	xbsbank_check7:SetVisible(true)
	xbsbank_check8:SetVisible(true)
	xbsbank_check9:SetVisible(true)
	xbsbank_check10:SetVisible(true)
	xbsbank_check11:SetVisible(true)
	xbsbank_check12:SetVisible(true)
	xbsbank_check13:SetVisible(true)
	xbsbank_check14:SetVisible(true)
	xbsbank_check15:SetVisible(true)
	--xbsbank_check16:SetVisible(true)
	--xbsbank_check17:SetVisible(true)
	xbsbank_auto:SetVisible(true)
	xbsbank_sortnow:SetVisible(true)
	
	--xbsbank_close:SetVisible(true)
	xbsbank_helpbutton:SetVisible(true)
	xbsbank_closebutton:SetVisible(true)
	
	xbsbank_lockbutton:SetVisible(true)
	xbsbank_lockbutton:SetTexture("xBagSort","textures/"..bank_settings[7]..".png")
	xbsbank_configbutton:SetVisible(true)
	xbsbank_button:SetVisible(false)
end


function xbsbank_button.Event:RightClick ()
	xbs_sort_now("bank","-echo")
end
function xbsbank_close.Event:LeftPress ()
	xbsbank_window:SetVisible(false)
	xbsbank_text:SetVisible(false)
	xbsbank_sortmethod:SetVisible(false)
	xbsbank_order:SetVisible(false)
	xbsbank_placement:SetVisible(false)
	xbsbank_speed:SetVisible(false)
	xbsbank_check1:SetVisible(false)
	xbsbank_check2:SetVisible(false)
	xbsbank_check3:SetVisible(false)
	xbsbank_check4:SetVisible(false)
	xbsbank_check5:SetVisible(false)
	xbsbank_check6:SetVisible(false)
	xbsbank_check7:SetVisible(false)
	xbsbank_check8:SetVisible(false)
	xbsbank_check9:SetVisible(false)
	xbsbank_check10:SetVisible(false)
	xbsbank_check11:SetVisible(false)
	xbsbank_check12:SetVisible(false)
	xbsbank_check13:SetVisible(false)
	xbsbank_check14:SetVisible(false)
	xbsbank_check15:SetVisible(false)
	--xbsbank_check16:SetVisible(false)
	--xbsbank_check17:SetVisible(false)
	xbsbank_auto:SetVisible(false)
	xbsbank_sortnow:SetVisible(false)
	xbsbank_close:SetVisible(false)
	xbsbank_lockbutton:SetVisible(false)
	xbsbank_configbutton:SetVisible(false)
	xbsbank_helpbutton:SetVisible(false)
	xbsbank_closebutton:SetVisible(false)
	xbsbank_button:SetVisible(true)
	
	if(xbsbank_auto:GetChecked()==true)then
		local query="bank"
		if(bank_settings[1]=="Type")then query=query.."type"
		elseif(bank_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..bank_settings[1] end
		if(bank_settings[2][1]==false)then query=query.."ignore01" end
		if(bank_settings[2][2]==false)then query=query.."ignore02" end
		if(bank_settings[2][3]==false)then query=query.."ignore03" end
		if(bank_settings[2][4]==false)then query=query.."ignore04" end
		if(bank_settings[2][5]==false)then query=query.."ignore05" end
		if(bank_settings[2][6]==false)then query=query.."ignore06" end
		if(bank_settings[2][7]==false)then query=query.."ignore07" end
		if(bank_settings[2][8]==false)then query=query.."ignore08" end
		if(bank_settings[2][9]==false)then query=query.."ignore09" end
		if(bank_settings[2][10]==false)then query=query.."ignore10" end
		if(bank_settings[2][11]==false)then query=query.."ignore11" end
		if(bank_settings[2][12]==false)then query=query.."ignore12" end
		if(bank_settings[2][13]==false)then query=query.."ignore13" end
		if(bank_settings[2][14]==false)then query=query.."ignore14" end
		if(bank_settings[2][15]==false)then query=query.."ignore15" end
		if(bank_settings[3]=="Z -> A")then query=query.."-i" end
		if(bank_settings[4]=="Empty First")then query=query.."-r" end
		if(bank_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(bank_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(bank_settings[5]=="Normal"))then query=query..bank_settings[5]end
		
		bankautosort=query
		print("Auto-sorting enabled using : "..bankautosort)
		print("Initial sorting commencing...")
		xbscommands(query)
	else
		bankautosort=nil
	end
	
end
local function xbs_bank_window_placement()
	if(bank_settings[6]=="TOPLEFT" or bank_settings[6]=="TOPCENTER" or bank_settings[6]=="TOPRIGHT")then 
		xbsbank_window:SetPoint("TOPLEFT", UI.Native.Bank,"TOPLEFT",(xbsbank_text:GetWidth()+0)*-0.5,(xbsbank_text:GetHeight()+75)*-1)
	elseif(bank_settings[6]=="BOTTOMLEFT" or bank_settings[6]=="BOTTOMCENTER" or bank_settings[6]=="BOTTOMRIGHT")then 
		xbsbank_window:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMCENTER",(xbsbank_text:GetWidth()+0)*-0.5,0)
	elseif(bank_settings[6]=="LEFTTOP" or bank_settings[6]=="CENTERLEFT" or bank_settings[6]=="LEFTBOTTOM")then 
		xbsbank_window:SetPoint("TOPLEFT", UI.Native.Bank,"TOPLEFT",(xbsbank_text:GetWidth()+0)*-1,0)
	elseif(bank_settings[6]=="RIGHTTOP" or bank_settings[6]=="CENTERRIGHT" or bank_settings[6]=="RIGHTBOTTOM")then 
		xbsbank_window:SetPoint("TOPLEFT", UI.Native.Bank,"TOPRIGHT",0,-10)
	end
end
local function xbs_bank_button_placement()
	--print("button placement")
	--print(bank_settings[6])
	xbsbank_button:SetVisible(false)
	if(bank_settings[6]=="TOPLEFT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"TOPLEFT",165,-9)
		
	elseif(bank_settings[6]=="TOPCENTER")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"TOPCENTER",24,-9)
	elseif(bank_settings[6]=="TOPRIGHT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_top.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"TOPRIGHT",-110,-9)
	elseif(bank_settings[6]=="BOTTOMLEFT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMLEFT",74,-11)
	elseif(bank_settings[6]=="BOTTOMCENTER")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMCENTER",24,-11)
	elseif(bank_settings[6]=="BOTTOMRIGHT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_bottom.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMRIGHT",-32,-11)
	elseif(bank_settings[6]=="RIGHTTOP")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"TOPRIGHT",56,55)
	elseif(bank_settings[6]=="CENTERRIGHT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"CENTERRIGHT",56,-32)
	elseif(bank_settings[6]=="RIGHTBOTTOM")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_right.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMRIGHT",56,-80)
	elseif(bank_settings[6]=="LEFTTOP")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"TOPLEFT",45,55)
		--print("button topleft")
	elseif(bank_settings[6]=="CENTERLEFT")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"CENTERLEFT",45,-32)
	elseif(bank_settings[6]=="LEFTBOTTOM")then
		xbsbank_button:SetTexture("xBagSort","textures/xbs_left.png")
		--xbsbank_button:ResizeToTexture()
		xbsbank_button:SetPoint("TOPLEFT", UI.Native.Bank,"BOTTOMLEFT",45,-74)
	end
	--xbsbank_button:SetVisible(true)
	xbsbank_button:SetLayer(3)
	xbs_bank_window_placement()
end
-- UI Setup
function xbs_setup()
		local xbssetup = UI.CreateFrame("RiftWindow", "xbssetupWindow", context)
		xbssetup:SetPoint("CENTER", UIParent,"CENTER")
		xbssetup:SetTitle("xBagSort Setup")
		xbssetup:SetLayer(7) 
		xbssetup:SetVisible(true) 
		--button
		local xbssetup_button = UI.CreateFrame("RiftButton", "xbssetupCloseButton", context)
		xbssetup_button:SetText("Finish")
		-- Put the button in the middle of the screen
		xbssetup_button:SetPoint("BOTTOMCENTER", xbssetup,"BOTTOMCENTER",0,-10)
		xbssetup_button:SetVisible(true) 
		xbssetup_button:SetLayer(8) 
		
		-- Run a function when the button is pressed
		-- Create our context --
		local xbssetup_text = UI.CreateFrame("Text", "xbssetupSampleText", context)
		-- Hello World! --
		
		xbssetup_text:SetText("Choose a location for the xBagSort Inventory and Bank UI button:\n\n\n\n\n\n\n\n\n\n\n\n\n\n Do not use UI:                                                    Do not use UI:\n\n\n\n")
		
			
		xbssetup_text:SetVisible(true) 
		-- Change the dimensions so all text is visible --
		xbssetup_text:SetWidth(xbssetup_text:GetWidth())
		xbssetup_text:SetHeight(xbssetup_text:GetHeight())
		xbssetup:SetWidth(xbssetup_text:GetWidth()+100)
		xbssetup:SetHeight(xbssetup_text:GetHeight()+100)
		xbssetup_text:SetLayer(8) 
		-- Put it at the top center of the game --
		xbssetup_text:SetPoint("TOPLEFT", xbssetup,"TOPLEFT",25,65)
		local xbssetup_inventory=UI.CreateFrame("Texture","xBagSortsetupgfx",context)
			xbssetup_inventory:SetVisible(true)
			xbssetup_inventory:SetTexture("xBagSort","textures/xbs_setup.jpg")
			--xbssetup_inventory:ResizeToTexture()
			xbssetup_inventory:SetPoint("CENTERCENTER", xbssetup,"LEFTCENTER",100,0)
			xbssetup_inventory:SetLayer(8)
			--print(xbssetup_inventory:GetWidth())
		local xbssetup_bank=UI.CreateFrame("Texture","xBagSortbanksetupgfx",context)
			xbssetup_bank:SetVisible(true)
			xbssetup_bank:SetTexture("xBagSort","textures/xbs_setup_bank.jpg")
			--xbssetup_bank:ResizeToTexture()
			xbssetup_bank:SetPoint("CENTERCENTER", xbssetup,"RIGHTCENTER",-110,0)
			xbssetup_bank:SetLayer(8)
		xbssetup_inventory_radio_group = Library.LibSimpleWidgets.RadioButtonGroup("xbssetup_inventory_radio_group")
			xbssetup_inventory_radio_group.Event.RadioButtonChange = function(self)
			  --print(self:GetName().." selected radio button = "..self:GetSelectedRadioButton():GetName())
			end
			local xbssetup_inventory_radioButton1 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton1", context)
			xbssetup_inventory_radioButton1:SetText("")
			xbssetup_inventory_radioButton1:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT",0,-7)
			xbssetup_inventory_radioButton1:SetLayer(9) 
			xbssetup_inventory_radioButton1.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton2 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton2",context)
			xbssetup_inventory_radioButton2:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT", xbssetup_inventory:GetWidth()/2-7,-7)
			xbssetup_inventory_radioButton2:SetText("")
			xbssetup_inventory_radioButton2:SetLayer(9)
			xbssetup_inventory_radioButton2.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton3 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton3", context)
			xbssetup_inventory_radioButton3:SetPoint("TOPLEFT", xbssetup_inventory,"TOPLEFT" , xbssetup_inventory:GetWidth()-14, -7)
			xbssetup_inventory_radioButton3:SetText("")
			xbssetup_inventory_radioButton3:SetLayer(9)
			xbssetup_inventory_radioButton3.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton4 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton4", context)
			xbssetup_inventory_radioButton4:SetText("")
			xbssetup_inventory_radioButton4:SetPoint("BOTTOMLEFT", xbssetup_inventory, "BOTTOMLEFT",0, 7)
			xbssetup_inventory_radioButton4:SetLayer(9) 
			xbssetup_inventory_radioButton4.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton5 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton5",context)
			xbssetup_inventory_radioButton5:SetPoint("BOTTOMLEFT", xbssetup_inventory, "BOTTOMLEFT", xbssetup_inventory:GetWidth()/2-7, 7)
			xbssetup_inventory_radioButton5:SetText("")
			xbssetup_inventory_radioButton5:SetLayer(9)
			xbssetup_inventory_radioButton5.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton6 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton6", context)
			xbssetup_inventory_radioButton6:SetPoint("BOTTOMLEFT", xbssetup_inventory,"BOTTOMLEFT" , xbssetup_inventory:GetWidth()-14, 7)
			xbssetup_inventory_radioButton6:SetText("")
			xbssetup_inventory_radioButton6:SetLayer(9)
			xbssetup_inventory_radioButton6.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			
			local xbssetup_inventory_radioButton7 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton7", context)
			xbssetup_inventory_radioButton7:SetText("")
			xbssetup_inventory_radioButton7:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT",-14, 7)
			xbssetup_inventory_radioButton7:SetLayer(9) 
			xbssetup_inventory_radioButton7.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton8 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton8",context)
			xbssetup_inventory_radioButton8:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT", -14, xbssetup_inventory:GetHeight()/2)
			xbssetup_inventory_radioButton8:SetText("")
			xbssetup_inventory_radioButton8:SetLayer(9)
			xbssetup_inventory_radioButton8.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton9 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton9", context)
			xbssetup_inventory_radioButton9:SetPoint("TOPLEFT", xbssetup_inventory,"TOPLEFT" , -14, xbssetup_inventory:GetHeight()-14)
			xbssetup_inventory_radioButton9:SetText("")
			xbssetup_inventory_radioButton9:SetLayer(9)
			xbssetup_inventory_radioButton9.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton10 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton10", context)
			xbssetup_inventory_radioButton10:SetText("")
			xbssetup_inventory_radioButton10:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT",xbssetup_inventory:GetWidth(), 7)
			xbssetup_inventory_radioButton10:SetLayer(9) 
			xbssetup_inventory_radioButton10.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton11 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton11",context)
			xbssetup_inventory_radioButton11:SetPoint("TOPLEFT", xbssetup_inventory, "TOPLEFT",xbssetup_inventory:GetWidth(), xbssetup_inventory:GetHeight()/2)
			xbssetup_inventory_radioButton11:SetText("")
			xbssetup_inventory_radioButton11:SetLayer(9)
			xbssetup_inventory_radioButton11.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton12 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton12", context)
			xbssetup_inventory_radioButton12:SetPoint("TOPLEFT", xbssetup_inventory,"TOPLEFT" , xbssetup_inventory:GetWidth(), xbssetup_inventory:GetHeight()-14)
			xbssetup_inventory_radioButton12:SetText("")
			xbssetup_inventory_radioButton12:SetLayer(9)
			xbssetup_inventory_radioButton12.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_inventory_radioButton13 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_inventory_radioButton13", context)
			xbssetup_inventory_radioButton13:SetPoint("TOPLEFT", xbssetup,"TOPLEFT" , 115, 315)
			xbssetup_inventory_radioButton13:SetText("")
			xbssetup_inventory_radioButton13:SetLayer(9)
			xbssetup_inventory_radioButton13.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton1)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton2)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton3)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton4)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton5)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton6)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton7)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton8)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton9)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton10)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton11)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton12)
			xbssetup_inventory_radio_group:AddRadioButton(xbssetup_inventory_radioButton13)
			xbssetup_bank_radio_group = Library.LibSimpleWidgets.RadioButtonGroup("xbssetup_bank_radio_group")
			xbssetup_bank_radio_group.Event.RadioButtonChange = function(self)
			  --print(self:GetName().." selected radio button = "..self:GetSelectedRadioButton():GetName())
			end
			local xbssetup_bank_radioButton1 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton1", context)
			xbssetup_bank_radioButton1:SetText("")
			xbssetup_bank_radioButton1:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT",0,-7)
			xbssetup_bank_radioButton1:SetLayer(9) 
			xbssetup_bank_radioButton1.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton2 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton2",context)
			xbssetup_bank_radioButton2:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT", xbssetup_bank:GetWidth()/2-7,-7)
			xbssetup_bank_radioButton2:SetText("")
			xbssetup_bank_radioButton2:SetLayer(9)
			xbssetup_bank_radioButton2.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton3 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton3", context)
			xbssetup_bank_radioButton3:SetPoint("TOPLEFT", xbssetup_bank,"TOPLEFT" , xbssetup_bank:GetWidth()-14, -7)
			xbssetup_bank_radioButton3:SetText("")
			xbssetup_bank_radioButton3:SetLayer(9)
			xbssetup_bank_radioButton3.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton4 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton4", context)
			xbssetup_bank_radioButton4:SetText("")
			xbssetup_bank_radioButton4:SetPoint("BOTTOMLEFT", xbssetup_bank, "BOTTOMLEFT",0, 7)
			xbssetup_bank_radioButton4:SetLayer(9) 
			xbssetup_bank_radioButton4.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton5 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton5",context)
			xbssetup_bank_radioButton5:SetPoint("BOTTOMLEFT", xbssetup_bank, "BOTTOMLEFT", xbssetup_bank:GetWidth()/2-7, 7)
			xbssetup_bank_radioButton5:SetText("")
			xbssetup_bank_radioButton5:SetLayer(9)
			xbssetup_bank_radioButton5.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton6 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton6", context)
			xbssetup_bank_radioButton6:SetPoint("BOTTOMLEFT", xbssetup_bank,"BOTTOMLEFT" , xbssetup_bank:GetWidth()-14, 7)
			xbssetup_bank_radioButton6:SetText("")
			xbssetup_bank_radioButton6:SetLayer(9)
			xbssetup_bank_radioButton6.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			
			local xbssetup_bank_radioButton7 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton7", context)
			xbssetup_bank_radioButton7:SetText("")
			xbssetup_bank_radioButton7:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT",-14, 7)
			xbssetup_bank_radioButton7:SetLayer(9) 
			xbssetup_bank_radioButton7.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton8 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton8",context)
			xbssetup_bank_radioButton8:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT", -14, xbssetup_bank:GetHeight()/2)
			xbssetup_bank_radioButton8:SetText("")
			xbssetup_bank_radioButton8:SetLayer(9)
			xbssetup_bank_radioButton8.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton9 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton9", context)
			xbssetup_bank_radioButton9:SetPoint("TOPLEFT", xbssetup_bank,"TOPLEFT" , -14, xbssetup_bank:GetHeight()-14)
			xbssetup_bank_radioButton9:SetText("")
			xbssetup_bank_radioButton9:SetLayer(9)
			xbssetup_bank_radioButton9.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton10 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton10", context)
			xbssetup_bank_radioButton10:SetText("")
			xbssetup_bank_radioButton10:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT",xbssetup_bank:GetWidth(), 7)
			xbssetup_bank_radioButton10:SetLayer(9) 
			xbssetup_bank_radioButton10.Event.RadioButtonSelect = function(self)
			
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton11 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton11",context)
			xbssetup_bank_radioButton11:SetPoint("TOPLEFT", xbssetup_bank, "TOPLEFT",xbssetup_bank:GetWidth(), xbssetup_bank:GetHeight()/2)
			xbssetup_bank_radioButton11:SetText("")
			xbssetup_bank_radioButton11:SetLayer(9)
			xbssetup_bank_radioButton11.Event.RadioButtonSelect = function(self)

			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton12 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton12", context)
			xbssetup_bank_radioButton12:SetPoint("TOPLEFT", xbssetup_bank,"TOPLEFT" , xbssetup_bank:GetWidth(), xbssetup_bank:GetHeight()-14)
			xbssetup_bank_radioButton12:SetText("")
			xbssetup_bank_radioButton12:SetLayer(9)
			xbssetup_bank_radioButton12.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			local xbssetup_bank_radioButton13 = UI.CreateFrame("SimpleRadioButton", "Myxbssetup_bank_radioButton13", context)
			xbssetup_bank_radioButton13:SetPoint("TOPLEFT", xbssetup,"TOPRIGHT" , -85, 315)
			xbssetup_bank_radioButton13:SetText("")
			xbssetup_bank_radioButton13:SetLayer(9)
			xbssetup_bank_radioButton13.Event.RadioButtonSelect = function(self)
			  --xbsinventory_button:SetVisible(false)
			end
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton1)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton2)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton3)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton4)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton5)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton6)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton7)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton8)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton9)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton10)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton11)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton12)
			xbssetup_bank_radio_group:AddRadioButton(xbssetup_bank_radioButton13)
	function xbssetup_button.Event:LeftPress ()
		if(xbssetup_inventory_radio_group:GetSelectedIndex())then
			local setup_selected=xbssetup_inventory_radio_group:GetSelectedIndex()
			
				if(setup_selected==1)then
					inv_settings[6]="TOPLEFT"
				elseif(setup_selected==2)then
					inv_settings[6]="TOPCENTER"
				elseif(setup_selected==3)then
					inv_settings[6]="TOPRIGHT"
				elseif(setup_selected==4)then
					inv_settings[6]="BOTTOMLEFT"
				elseif(setup_selected==5)then
					inv_settings[6]="BOTTOMCENTER"
				elseif(setup_selected==6)then
					inv_settings[6]="BOTTOMRIGHT"
				elseif(setup_selected==7)then
					inv_settings[6]="LEFTTOP"
				elseif(setup_selected==8)then
					inv_settings[6]="CENTERLEFT"
				elseif(setup_selected==9)then
					inv_settings[6]="LEFTBOTTOM"
				elseif(setup_selected==10)then
					inv_settings[6]="RIGHTTOP"
				elseif(setup_selected==11)then
					inv_settings[6]="CENTERRIGHT"
				elseif(setup_selected==12)then
					inv_settings[6]="RIGHTBOTTOM"
				end
				xbssetbanksettings(xbssetup_bank_radio_group:GetSelectedIndex())
				if(setup_selected==13)then
					inv_settings[6]="NONE"
					invui=false
					xbsinventory_button:SetVisible(false)
					xbsinventory_window:SetVisible(false)
					xbsinventory_text:SetVisible(false)
					xbsinventory_sortmethod:SetVisible(false)
					xbsinventory_order:SetVisible(false)
					xbsinventory_placement:SetVisible(false)
					xbsinventory_speed:SetVisible(false)
					xbsinventory_check1:SetVisible(false)
					xbsinventory_check2:SetVisible(false)
					xbsinventory_check3:SetVisible(false)
					xbsinventory_check4:SetVisible(false)
					xbsinventory_check5:SetVisible(false)
					xbsinventory_check6:SetVisible(false)
					xbsinventory_check7:SetVisible(false)
					xbsinventory_auto:SetVisible(false)
					xbsinventory_sortnow:SetVisible(false)
					xbsinventory_close:SetVisible(false)
					xbsinventory_helpbutton:SetVisible(false)
					xbsinventory_closebutton:SetVisible(false)
					xbsinventory_lockbutton:SetVisible(false)
					xbsinventory_configbutton:SetVisible(false)
				end
					xbssetup:SetVisible(false)
					xbssetup_button:SetVisible(false)
					xbssetup_text:SetVisible(false)
					xbssetup_inventory:SetVisible(false)
					--xbssetup_inventory_radio_group:SetVisible(false)
					xbssetup_inventory_radioButton1:SetVisible(false)
					xbssetup_inventory_radioButton2:SetVisible(false)
					xbssetup_inventory_radioButton3:SetVisible(false)
					xbssetup_inventory_radioButton4:SetVisible(false)
					xbssetup_inventory_radioButton5:SetVisible(false)
					xbssetup_inventory_radioButton6:SetVisible(false)
					xbssetup_inventory_radioButton7:SetVisible(false)
					xbssetup_inventory_radioButton8:SetVisible(false)
					xbssetup_inventory_radioButton9:SetVisible(false)
					xbssetup_inventory_radioButton10:SetVisible(false)
					xbssetup_inventory_radioButton11:SetVisible(false)
					xbssetup_inventory_radioButton12:SetVisible(false)
					xbssetup_inventory_radioButton13:SetVisible(false)
					xbssetup:SetVisible(false)
					xbssetup_button:SetVisible(false)
					xbssetup_text:SetVisible(false)
					xbssetup_bank:SetVisible(false)
					--xbssetup_bank_radio_group:SetVisible(false)
					xbssetup_bank_radioButton1:SetVisible(false)
					xbssetup_bank_radioButton2:SetVisible(false)
					xbssetup_bank_radioButton3:SetVisible(false)
					xbssetup_bank_radioButton4:SetVisible(false)
					xbssetup_bank_radioButton5:SetVisible(false)
					xbssetup_bank_radioButton6:SetVisible(false)
					xbssetup_bank_radioButton7:SetVisible(false)
					xbssetup_bank_radioButton8:SetVisible(false)
					xbssetup_bank_radioButton9:SetVisible(false)
					xbssetup_bank_radioButton10:SetVisible(false)
					xbssetup_bank_radioButton11:SetVisible(false)
					xbssetup_bank_radioButton12:SetVisible(false)
					xbssetup_bank_radioButton13:SetVisible(false)
					xbs_bank_button_placement()
					xbs_inventory_button_placement()
				end
				if(UI.Native.BagInventory1:GetLoaded()==true and invui=="locked")then
					xbsinventory_button.Event:LeftUp()
				elseif(UI.Native.BagInventory1:GetLoaded()==true and invui==true)then
					xbsinventory_button:SetVisible(true)
				end
				if(UI.Native.Bank:GetLoaded()==true and bankui=="locked")then
					xbsbank_button.Event:LeftUp()
				elseif(UI.Native.Bank:GetLoaded()==true and invui==true)then
					xbsbank_button:SetVisible(true)
				end
				invui=true
				
			
	end
end
function xbssetbanksettings(place)
	local bank_s
				if(place==1)then
					bank_s="TOPLEFT"
				elseif(place==2)then
					bank_s="TOPCENTER"
				elseif(place==3)then
					bank_s="TOPRIGHT"
				elseif(place==4)then
					bank_s="BOTTOMLEFT"
				elseif(place==5)then
					bank_s="BOTTOMCENTER"
				elseif(place==6)then
					bank_s="BOTTOMRIGHT"
				elseif(place==7)then
					bank_s="LEFTTOP"
				elseif(place==8)then
					bank_s="CENTERLEFT"
				elseif(place==9)then
					bank_s="LEFTBOTTOM"
				elseif(place==10)then
					bank_s="RIGHTTOP"
				elseif(place==11)then
					bank_s="CENTERRIGHT"
				elseif(place==12)then
					bank_s="RIGHTBOTTOM"
				elseif(place==13)then
					bank_s="NONE"
				end
	if(place==13)then
			bank_settings[6]="NONE"
			bankui=false
			xbsbank_button:SetVisible(false)
			xbsbank_window:SetVisible(false)
			xbsbank_text:SetVisible(false)
			xbsbank_sortmethod:SetVisible(false)
			xbsbank_order:SetVisible(false)
			xbsbank_placement:SetVisible(false)
			xbsbank_speed:SetVisible(false)
			xbsbank_check1:SetVisible(false)
			xbsbank_check2:SetVisible(false)
			xbsbank_check3:SetVisible(false)
			xbsbank_check4:SetVisible(false)
			xbsbank_check5:SetVisible(false)
			xbsbank_check6:SetVisible(false)
			xbsbank_check7:SetVisible(false)
			xbsbank_check8:SetVisible(false)
			xbsbank_check9:SetVisible(false)
			xbsbank_auto:SetVisible(false)
			xbsbank_sortnow:SetVisible(false)
			xbsbank_close:SetVisible(false)
			xbsbank_helpbutton:SetVisible(false)
			xbsbank_closebutton:SetVisible(false)
			xbsbank_lockbutton:SetVisible(false)
			xbsbank_configbutton:SetVisible(false)
		end
		
		xbs_bank_button_placement()
	
	if(UI.Native.Bank:GetLoaded()==true and bankui=="locked")then
		xbsbank_button.Event:LeftUp()
	elseif(UI.Native.Bank:GetLoaded()==true and bankui==true)then
		xbsbank_button:SetVisible(true)
	end
	bankui=true
	bank_settings[6]=bank_s
	print("Bank setttings set")
	end
	
	
	
function xbs_sort_now(arg, extras)
	if(extras==nil)then
		extras=""
		end
	if(arg=="bank") then
		local query="bank "
		if(bank_settings[1]=="Type")then query=query.."type"
		elseif(bank_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..bank_settings[1] end
		if(bank_settings[2][1]==false)then query=query.."ignore01" end
		if(bank_settings[2][2]==false)then query=query.."ignore02" end
		if(bank_settings[2][3]==false)then query=query.."ignore03" end
		if(bank_settings[2][4]==false)then query=query.."ignore04" end
		if(bank_settings[2][5]==false)then query=query.."ignore05" end
		if(bank_settings[2][6]==false)then query=query.."ignore06" end
		if(bank_settings[2][7]==false)then query=query.."ignore07" end
		if(bank_settings[2][8]==false)then query=query.."ignore08" end
		if(bank_settings[2][9]==false)then query=query.."ignore09" end
		if(bank_settings[2][10]==false)then query=query.."ignore10" end
		if(bank_settings[2][11]==false)then query=query.."ignore11" end
		if(bank_settings[2][12]==false)then query=query.."ignore12" end
		if(bank_settings[2][13]==false)then query=query.."ignore13" end
		if(bank_settings[2][14]==false)then query=query.."ignore14" end
		if(bank_settings[2][15]==false)then query=query.."ignore15" end
		if(bank_settings[3]=="Z -> A")then query=query.."-i" end
		if(bank_settings[4]=="Empty First")then query=query.."-r" end
		if(bank_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(bank_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(bank_settings[5]=="Normal"))then query=query..bank_settings[5]end
		if(xbsbank_auto:GetChecked()==true)then
			bankautosort=query
		else
			bankautosort=nil
		end
		--print(query)
		
		xbscommands(query..extras)
	else
	local query=""
		if(inv_settings[1]=="Type")then query=query.."type"
		elseif(inv_settings[1]=="Auction House")then query=query.."ah"
		
		else query=query..inv_settings[1] end
		if(inv_settings[2][1]==false)then query=query.."ignore01" end
		if(inv_settings[2][2]==false)then query=query.."ignore02" end
		if(inv_settings[2][3]==false)then query=query.."ignore03" end
		if(inv_settings[2][4]==false)then query=query.."ignore04" end
		if(inv_settings[2][5]==false)then query=query.."ignore05" end
		if(inv_settings[2][6]==false)then query=query.."ignore06" end
		if(inv_settings[2][7]==false)then query=query.."ignore07" end
		if(inv_settings[3]=="Z -> A")then query=query.."-i" end
		if(inv_settings[4]=="Empty First")then query=query.."-r" end
		if(inv_settings[5]=="-9 (Fastest)")then query=query.."-9"
		elseif(inv_settings[5]=="+9 (Slowest)")then query=query.."+9"
		elseif(not(inv_settings[5]=="Normal"))then query=query..inv_settings[5]end
		if(xbsinventory_auto:GetChecked()==true)then
			autosort=query
		else
			autosort=nil
		end
		--print(query)
		xbscommands(query..extras)
	end
end
	
	
	
	
	
	
	
	
function xbscommands(command)
	if(xbs_DEBUG)then
		print("Function xbscommands: "..command)
	end
	if(xbsbankqueue=="inventory" and command.find(command,"bank"))then
		return
	end
	lastcheckedtime = Inspect.Time.Real()+1
	location="inventory"
	last_changed=500
	sort_delay=1
	xbs_DEBUG=nil
	use_throttle=nil
	sort_list={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
	extra_throttle_number=0
	extra_throttle=0
	invert=nil
	rear=nil
	echo="yes"
	local command=string.lower(command)
	if(command.find(command,"help"))then
		if(xbsbutton:GetVisible())then
			xbsbutton:SetVisible(false)
			xbswindow:SetVisible(false)
			xbstext:SetVisible(false) 
		else
			xbsbutton:SetVisible(true)
			xbswindow:SetVisible(true)
			xbstext:SetVisible(true) 
			end
		end
	if(command.find(command,"debugappend"))then--Add debug tag to autosorting calls
		autosort = autosort.."debug"
		end
	if(command.find(command,"-echo"))then
		echo=nil
		end
	if(command.find(command,"test"))then
		table.foreach(_G,print)
		end
	if(command.find(command,"debug"))then
		xbs_DEBUG=1
		end
	if(command.find(command,"setup"))then
		xbs_setup()
		end
	if(command.find(command,"guild"))then
		commanduicheck=string.gsub(command,"guild", "")
		if(commanduicheck.find(commanduicheck,"ui"))then
			if(invui)then
				invui=false
				print("UI Disabled")
				xbsinventory_window:SetVisible(false)
				xbsinventory_text:SetVisible(false)
				xbsinventory_sortmethod:SetVisible(false)
				xbsinventory_order:SetVisible(false)
				xbsinventory_placement:SetVisible(false)
				xbsinventory_speed:SetVisible(false)
				xbsinventory_check1:SetVisible(false)
				xbsinventory_check2:SetVisible(false)
				xbsinventory_check3:SetVisible(false)
				xbsinventory_check4:SetVisible(false)
				xbsinventory_check5:SetVisible(false)
				xbsinventory_check6:SetVisible(false)
				xbsinventory_check7:SetVisible(false)
				xbsinventory_auto:SetVisible(false)
				xbsinventory_sortnow:SetVisible(false)
				xbsinventory_close:SetVisible(false)
				xbsinventory_lockbutton:SetVisible(false)
				xbsinventory_configbutton:SetVisible(false)
				xbsinventory_helpbutton:SetVisible(false)
				xbsinventory_closebutton:SetVisible(false)
				xbsinventory_button:SetVisible(false)
			else
				invui=true
				print("UI Enabled")
				
			end
		end
	else
		if(command.find(command,"ui"))then
			if(invui)then
				invui=false
				print("UI Disabled")
				xbsinventory_window:SetVisible(false)
				xbsinventory_text:SetVisible(false)
				xbsinventory_sortmethod:SetVisible(false)
				xbsinventory_order:SetVisible(false)
				xbsinventory_placement:SetVisible(false)
				xbsinventory_speed:SetVisible(false)
				xbsinventory_check1:SetVisible(false)
				xbsinventory_check2:SetVisible(false)
				xbsinventory_check3:SetVisible(false)
				xbsinventory_check4:SetVisible(false)
				xbsinventory_check5:SetVisible(false)
				xbsinventory_check6:SetVisible(false)
				xbsinventory_check7:SetVisible(false)
				xbsinventory_auto:SetVisible(false)
				xbsinventory_sortnow:SetVisible(false)
				xbsinventory_close:SetVisible(false)
				xbsinventory_helpbutton:SetVisible(false)
				xbsinventory_closebutton:SetVisible(false)
				xbsinventory_lockbutton:SetVisible(false)
				xbsinventory_configbutton:SetVisible(false)
				xbsinventory_button:SetVisible(false)
			else
				invui=true
				print("UI Enabled")
			end
		end
		end
	if(command.find(command,"throttle"))then
		use_throttle=1
		end
	if(command.find(command,"invert") or command.find(command,"-i"))then
		invert=1
		end
	if(command.find(command,"rear") or command.find(command,"-r"))then
		rear=1
		end
	if(command.find(command,"off"))then
		if(autosort)then
			print("Auto-sort command was : "..autosort)
		end
		print("Auto-sorting now disabled.")
		autosort=nil
		end
	if(command.find(command,"show"))then
		if(autosort)then
			print("Auto-sorting enabled using : "..autosort)
		else
			print("Auto-sorting is currently disabled.")
			end
		end
	if(command.find(command,"-1"))then
		sort_delay=0.9
	elseif(command.find(command,"-2"))then
		sort_delay=0.8
	elseif(command.find(command,"-3"))then
		sort_delay=0.7
	elseif(command.find(command,"-4"))then
		sort_delay=0.6
	elseif(command.find(command,"-5"))then
		sort_delay=0.5
	elseif(command.find(command,"-6"))then
		sort_delay=0.4
	elseif(command.find(command,"-7"))then
		sort_delay=0.3
	elseif(command.find(command,"-8"))then
		sort_delay=0.2
	elseif(command.find(command,"-9"))then
		sort_delay=0.1
	elseif(command.find(command,"+1"))then
		sort_delay=1.1
	elseif(command.find(command,"+2"))then
		sort_delay=1.2
	elseif(command.find(command,"+3"))then
		sort_delay=1.3
	elseif(command.find(command,"+4"))then
		sort_delay=1.4
	elseif(command.find(command,"+5"))then
		sort_delay=1.5
	elseif(command.find(command,"+6"))then
		sort_delay=1.6
	elseif(command.find(command,"+7"))then
		sort_delay=1.7
	elseif(command.find(command,"+8"))then
		sort_delay=1.8
	elseif(command.find(command,"+9"))then
		sort_delay=1.9
		end
	if(command.find(command,"ignore01"))then
		sort_list[1]=nil
		end
	if(command.find(command,"ignore02"))then
		sort_list[2]=nil
		end
	if(command.find(command,"ignore03"))then
		sort_list[3]=nil
		end
	if(command.find(command,"ignore04"))then
		sort_list[4]=nil
		end
	if(command.find(command,"ignore05"))then
		sort_list[5]=nil
		end
	if(command.find(command,"ignore06"))then
		sort_list[6]=nil
		end
	if(command.find(command,"ignore07"))then
		sort_list[7]=nil
		end
	if(command.find(command,"ignore08"))then
		sort_list[8]=nil
		end
	if(command.find(command,"ignore09"))then
		sort_list[9]=nil
		end
	if(command.find(command,"ignore10"))then
		sort_list[10]=nil
		end
	if(command.find(command,"ignore11"))then
		sort_list[11]=nil
		end
	if(command.find(command,"ignore12"))then
		sort_list[12]=nil
		end
	if(command.find(command,"ignore13"))then
		sort_list[13]=nil
		end
	if(command.find(command,"ignore14"))then
		sort_list[14]=nil
		end
	if(command.find(command,"ignore15"))then
		sort_list[15]=nil
		end
	if(command.find(command,"bv"))then
		if(command.find(command,"bv1"))then
			location="bv1"
		elseif(command.find(command,"bv2"))then
			location="bv2"
		elseif(command.find(command,"bv3"))then
			location="bv3"
		elseif(command.find(command,"bv4"))then
			location="bv4"
		elseif(command.find(command,"bv5"))then
			location="bv5"
		elseif(command.find(command,"bv6"))then
			location="bv6"
		elseif(command.find(command,"bv7"))then
			location="bv7"
		else
			print("No bank vault specified, please use format \"bv#\" where # is the vault you wish to sort.")
			end
		if(command.find(command,"name"))then
			sorting=1
			sort_iteration=0
			sort_by="name"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort "..location.." by name")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"type"))then
			sorting=1
			sort_iteration=0
			sort_by="category"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort "..location.." by type") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"quantity"))then
			sorting=1
			sort_iteration=0
			sort_by="stack"
			sort_or_not="yes"
			if(invert==1)then
				invert=0
			else
				invert=1
			end
			if(echo)then print("Beginning to sort "..location.." by quantity") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"rarity"))then
			sorting=1
			sort_iteration=0
			sort_by="rarity"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort "..location.." by item quality")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"ah"))then
			sorting=1
			sort_iteration=0
			sort_by="ah"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort "..location.." by AH order") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"condense"))then
			sorting=1
			sort_iteration=0
			sort_by="condense"
			--sort_or_not="no"
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
			if(echo)then print("Beginning to condense "..location) end
		elseif(command.find(command,"abort"))then
			sorting=1
			sort_iteration=20
			print("Attmpting to abort sorting...")
		else
			print("Type /xbs help for list of commands")
			end	
		
	elseif(command.find(command,"bank"))then
		location="bank"
		if(command.find(command,"name"))then
			sorting=1
			sort_iteration=0
			sort_by="name"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort bank by name")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"type"))then
			sorting=1
			sort_iteration=0
			sort_by="category"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort bank by type") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"quantity"))then
			sorting=1
			sort_iteration=0
			sort_by="stack"
			sort_or_not="yes"
			if(invert==1)then
				invert=0
			else
				invert=1
			end
			if(echo)then print("Beginning to sort bank by quantity") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"rarity"))then
			sorting=1
			sort_iteration=0
			sort_by="rarity"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort bank by item quality")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"ah"))then
			sorting=1
			sort_iteration=0
			sort_by="ah"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort bank by AH order") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"condense"))then
			sorting=1
			sort_iteration=0
			sort_by="condense"
			--sort_or_not="no"
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
			if(echo)then print("Beginning to condense bank") end
		elseif(command.find(command,"abort"))then
			sorting=1
			sort_iteration=20
			print("Attmpting to abort sorting...")
		else
			print("Type /xbs help for list of commands")
			end
	elseif(command.find(command,"guild"))then
		guilded=Inspect.Unit.Detail("player")
		guilded=guilded["guild"]
		if(guilded==nil)then
			print("Not in a guild, unable to sort guild bank.")
			end
			
		if(command.find(command,"guild1"))then
			location="verifyguild1"
		elseif(command.find(command,"guild2"))then
			location="verifyguild2"
		elseif(command.find(command,"guild3"))then
			location="verifyguild3"
		elseif(command.find(command,"guild4"))then
			location="verifyguild4"
		elseif(command.find(command,"guild5"))then
			location="verifyguild5"
		else
			print("No vault specified, please use format \"guild#\" where # is the vault you wish to sort.")
			end
		if(command.find(command,"name"))then
			sorting=1
			sort_iteration=0
			sort_by="name"
			sort_or_not="yes"
			print("Beginning to sort guild bank by name")
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"type"))then
			sorting=1
			sort_iteration=0
			sort_by="category"
			sort_or_not="yes"
			print("Beginning to sort guild bank by type")
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"quantity"))then
			sorting=1
			sort_iteration=0
			sort_by="stack"
			sort_or_not="yes"
			if(invert==1)then
				invert=0
			else
				invert=1
			end
			print("Beginning to sort guild bank by quantity")
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"rarity"))then
			sorting=1
			sort_iteration=0
			sort_by="rarity"
			sort_or_not="yes"
			print("Beginning to sort guild bank by item quality")
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"ah"))then
			sorting=1
			sort_iteration=0
			sort_by="ah"
			sort_or_not="yes"
			print("Beginning to sort guild bank by AH order")
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"condense"))then
			sorting=1
			sort_iteration=0
			sort_by="condense"
			--sort_or_not="no"
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
			print("Beginning to condense guild bank")
		elseif(command.find(command,"abort"))then
			sorting=1
			sort_iteration=20
			print("Attmpting to abort sorting...")
		else
			print("Type /xbs help for list of commands")
			end
	else
		if(command.find(command,"autosort")) then
			if(command.find(command,"show"))then
				if(autosort)then
					print("Auto-sorting enabled using : "..autosort)
				else
					print("Auto-sorting is currently disabled.")
				end
			else
				autosort=string.gsub(command,"autosort", "")
				print("Auto-sorting enabled using : "..autosort)
				print("Initial sorting commencing...")
			end
		end
		if(command.find(command,"auto")) then
			if(command.find(command,"show"))then
				if(autosort)then
					print("Auto-sorting enabled using : "..autosort)
				else
					print("Auto-sorting is currently disabled.")
				end
			else
				autosort=string.gsub(command,"auto", "")
				print("Auto-sorting enabled using : "..autosort)
				print("Initial sorting commencing...")
			end
		end
		if(command.find(command,"name"))then
			sorting=1
			sort_iteration=0
			sort_by="name"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort inventory by name") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"type"))then
			sorting=1
			sort_iteration=0
			sort_by="category"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort inventory by type") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"quantity"))then
			sorting=1
			sort_iteration=0
			sort_by="stack"
			sort_or_not="yes"
			if(invert==1)then
				invert=0
			else
				invert=1
			end
			if(echo)then print("Beginning to sort inventory by quantity") end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"rarity"))then
			sorting=1
			sort_iteration=0
			sort_by="rarity"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort inventory by item quality")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
		elseif(command.find(command,"ah"))then
			sorting=1
			sort_iteration=0
			sort_by="ah"
			sort_or_not="yes"
			if(echo)then print("Beginning to sort inventory by AH order")end
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
			
		elseif(command.find(command,"condense"))then
			sorting=1
			sort_iteration=0
			sort_by="condense"
			--sort_or_not="no"
			sorter_event_id={xsorter, "xBagSort", "refresh" }
			table.insert(Event.System.Update.Begin,sorter_event_id)
			if(echo)then print("Beginning to condense inventory")end
		elseif(command.find(command,"abort"))then
			sorting=1
			sort_iteration=20
			print("Attmpting to abort sorting...")
		else
			--print("Type /xbs help for list of commands")
			end
		end
end

local function xbagsort()
	lastcheckedtime = Inspect.Time.Real()+1
	location="inventory"
	sorting=1
	sort_iteration=0
	sort_by="name"
	--sort_or_not="no"
	sorter_event_id={xsorter, "xBagSort", "refresh" }
	table.insert(Event.System.Update.Begin,sorter_event_id)
	print("Beginning to condense bags")
end

table.insert(Command.Slash.Register("xbagsort"), {xbagsort, "xBagSort", "xbagsort"})
table.insert(Command.Slash.Register(	"xbs"), {xbscommands, "xBagSort", "xbs"})


--Begin Saving/Loading
local function xbsSave(addon)
	if(addon=="xBagSort") then
		xbsautosort=autosort
		xbsbankautosort=bankautosort
		xbsui=invui
		xbsbui=bankui
		xbsinventory=inv_settings
		xbsbank=bank_settings
	end
end

local function xbsLoad(addon)
	if(addon=="xBagSort") then
		if(xbsautosort)then
			autosort=xbsautosort
			xbsinventory_auto:SetChecked(true)
		else
			autosort=nil
		end
		if(xbsbankautosort)then
			bankautosort=xbsbankautosort
			xbsbank_auto:SetChecked(true)
		else
			autosort=nil
		end
		
		if(xbsui)then
			invui=xbsui
		else
			invui=false
		end
		if(xbsbui)then
			bankui=xbsui
		else
			bankui=false
		end
		if(xbsinventory)then
			inv_settings=xbsinventory
			if(inv_settings[2][6]==nil)then
				inv_settings[2][6]=true
				inv_settings[2][7]=true
			end
			xbsinventory_sortmethod:SetSelectedItem(inv_settings[1], true)
			xbsinventory_check1:SetChecked(inv_settings[2][1])
			xbsinventory_check2:SetChecked(inv_settings[2][2])
			xbsinventory_check3:SetChecked(inv_settings[2][3])
			xbsinventory_check4:SetChecked(inv_settings[2][4])
			xbsinventory_check5:SetChecked(inv_settings[2][5])
			xbsinventory_check6:SetChecked(inv_settings[2][6])
			xbsinventory_check7:SetChecked(inv_settings[2][7])
			xbsinventory_order:SetSelectedItem(inv_settings[3], true)
			xbsinventory_placement:SetSelectedItem(inv_settings[4], true)
			xbsinventory_speed:SetSelectedItem(inv_settings[5], true)
			if(inv_settings[7]==nil)then
				inv_settings[7]="unlocked"
			elseif(inv_settings[7]=="locked")then
				xbsinventory_lockbutton:SetTexture("xBagSort","textures/locked.png")
			end
			if(inv_settings[6]==nil or inv_settings[6]=="NOT_SET")then
				xbs_setup()
				
			else
				xbs_inventory_button_placement()
			end
			
		else
			inv_settings={"Name",{true,true,true,true,true,true,true},"A -> Z", "Items First","Normal","NOT_SET","unlocked"}
		end
		if(xbsbank)then
			
			bank_settings=xbsbank
			if(bank_settings[2][10]==nil)then --v14 settings update
				bank_settings[2][10]=false
				bank_settings[2][11]=false
				bank_settings[2][12]=false
				bank_settings[2][13]=false
				bank_settings[2][14]=false
				bank_settings[2][15]=false
				bank_settings[2][16]=false
				bank_settings[2][17]=false
				end
			xbsbank_sortmethod:SetSelectedItem(bank_settings[1], true)
			xbsbank_check1:SetChecked(bank_settings[2][1])
			xbsbank_check2:SetChecked(bank_settings[2][2])
			xbsbank_check3:SetChecked(bank_settings[2][3])
			xbsbank_check4:SetChecked(bank_settings[2][4])
			xbsbank_check5:SetChecked(bank_settings[2][5])
			xbsbank_check6:SetChecked(bank_settings[2][6])
			xbsbank_check7:SetChecked(bank_settings[2][7])
			xbsbank_check8:SetChecked(bank_settings[2][8])
			xbsbank_check9:SetChecked(bank_settings[2][9])
			xbsbank_check10:SetChecked(bank_settings[2][10])
			xbsbank_check11:SetChecked(bank_settings[2][11])
			xbsbank_check12:SetChecked(bank_settings[2][12])
			xbsbank_check13:SetChecked(bank_settings[2][13])
			xbsbank_check14:SetChecked(bank_settings[2][14])
			xbsbank_check15:SetChecked(bank_settings[2][15])
			--xbsbank_check16:SetChecked(bank_settings[2][16])
			--xbsbank_check17:SetChecked(bank_settings[2][17])
			xbsbank_order:SetSelectedItem(bank_settings[3], true)
			xbsbank_placement:SetSelectedItem(bank_settings[4], true)
			xbsbank_speed:SetSelectedItem(bank_settings[5], true)
			if(bank_settings[7]==nil)then
				bank_settings[7]="unlocked"
			elseif(bank_settings[7]=="locked")then
				xbsbank_lockbutton:SetTexture("xBagSort","textures/locked.png")
				bankui="locked"
			end
			if(bank_settings[6]==nil or bank_settings[6]=="NOT_SET")then
				xbs_setup()
				
			else
				xbs_bank_button_placement()
			end
			
		else
			bank_settings={"Name",{true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true},"A -> Z", "Items First","Normal","NOT_SET","unlocked"}
			xbs_setup()
		end
	end
end
table.insert(Event.Addon.SavedVariables.Save.Begin, {xbsSave, "xBagSort", "saving"})
table.insert(Event.Addon.SavedVariables.Load.End, {xbsLoad, "xBagSort", "loading"})
